// Copyright (c) 2023 The Bitcoin developers
// Distributed under the MIT software license, see the accompanying
// file COPYING or http://www.opensource.org/licenses/mit-license.php.

#ifndef BITCOIN_POLICY_BLOCK_STAKINGREWARDS_H
#define BITCOIN_POLICY_BLOCK_STAKINGREWARDS_H

#include <policy/block/parkingpolicy.h>

struct Amount;
class CBlock;
class CBlockIndex;

class StakingRewardsPolicy : public ParkingPolicy {
private:
    const CBlock &m_block;
    const Amount &m_blockReward;
    const CBlockIndex &m_blockIndex;

public:
    StakingRewardsPolicy(const CBlockIndex &blockIndex, const CBlock &block,
                         const Amount &blockReward)
        : m_block(block), m_blockReward(blockReward), m_blockIndex(blockIndex) {
    }

    bool operator()(BlockPolicyValidationState &state) override;
};

Amount GetStakingRewardsAmount(const Amount &coinbaseValue);

#endif // BITCOIN_POLICY_BLOCK_STAKINGREWARDS_H
