// Copyright (c) 2023 The Bitcoin developers
// Distributed under the MIT software license, see the accompanying
// file COPYING or http://www.opensource.org/licenses/mit-license.php.
export const navitems = [
    {
        nav_item: 'About',
        dropdown_items: [
            {
                title: 'Wealth Redefined',
                link: '/wealth-redefined',
                icon: '/images/hand-diamond-icon.svg',
            },
            {
                title: 'Core Tech',
                link: '/core-tech',
                icon: '/images/cube-icon.svg',
            },
            {
                title: 'FAQ',
                link: '/faq',
                icon: '/images/hands-logo-icon.svg',
            },
            {
                title: 'Roadmap',
                link: '/roadmap',
                icon: '/images/roadmap-icon.svg',
            },
            {
                title: 'eCash Brand',
                link: '/brand',
                icon: '/images/dna-icon.svg',
            },
        ],
    },
    {
        nav_item: 'Developers',
        link: '/developers',
    },
    {
        nav_item: 'Technology',
        dropdown_items: [
            {
                title: 'Releases',
                link: 'https://www.bitcoinabc.org/releases/',
                icon: '/images/hand-logo-icon.svg',
            },
            {
                title: 'Source Code',
                link: 'https://github.com/bitcoin-abc/bitcoin-abc/',
                icon: '/images/hand-code-icon.svg',
            },
            {
                title: 'Documentation',
                link: 'https://www.bitcoinabc.org/doc/',
                icon: '/images/document-icon.svg',
            },
        ],
    },
    {
        nav_item: 'Get eCash',
        dropdown_items: [
            {
                title: 'Exchanges',
                link: '/get-ecash#exchanges',
                icon: '/images/refresh-logo-icon.svg',
            },
            {
                title: 'Wallets',
                link: '/wallets',
                icon: '/images/wallet-icon.svg',
            },
            {
                title: 'Services',
                link: '/get-ecash#services',
                icon: '/images/services-icon.svg',
            },
            {
                title: 'Mining',
                link: '/get-ecash#mining',
                icon: '/images/mining-icon.svg',
            },
        ],
    },
    {
        nav_item: 'Blog',
        link: '/blog',
    },
    {
        nav_item: 'More',
        dropdown_items: [
            {
                title: 'GNC',
                link: 'https://gnc.e.cash',
                icon: '/images/hands-logo-icon.svg',
            },
            {
                title: 'Avalanche on eCash',
                link: 'https://avalanche.cash/',
                icon: '/images/mountain-icon.svg',
            },
            {
                title: 'eCash Scorecard',
                link: 'https://scorecard.cash/',
                icon: '/images/hand-stars-icon.svg',
            },
            {
                title: 'eCash Supply',
                link: 'https://ecash.supply/',
                icon: '/images/hand-cube-icon.svg',
            },
            {
                title: 'eCash Explorer',
                link: 'https://explorer.e.cash/',
                icon: '/images/cube-icon.svg',
            },
            {
                title: 'eCash Community',
                link: 'https://ecash.community',
                icon: '/images/hands-icon.svg',
            },
            {
                title: 'Career Opportunities',
                link: 'careers',
                icon: '/images/people-icon.svg',
            },
        ],
    },
];
