// Copyright (c) 2023 The Bitcoin developers
// Distributed under the MIT software license, see the accompanying
// file COPYING or http://www.opensource.org/licenses/mit-license.php.

/**
 * @generated from https://api.scorecard.cash/exchanges
 */

export const mockExchanges = [
    {
        id: 1,
        name: 'Binance',
        published_at: '2022-02-03T22:59:16.000Z',
        created_at: '2022-02-03T22:59:13.000Z',
        updated_at: '2022-11-18T20:36:19.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.binance.com/en/trade/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT', 'BUSD'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: true,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['EUR', 'GBP', 'NZD', 'RUB', 'TRY', 'UAH', 'USD'],
        logo: {
            id: 1,
            name: 'binance.png',
            alternativeText: 'Binance',
            caption: '',
            width: 249,
            height: 50,
            formats: {
                thumbnail: {
                    name: 'thumbnail_binance.png',
                    hash: 'thumbnail_binance_64d10b4b7d',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 49,
                    size: 6.31,
                    path: null,
                    url: '/uploads/thumbnail_binance_64d10b4b7d.png',
                },
            },
            hash: 'binance_64d10b4b7d',
            ext: '.png',
            mime: 'image/png',
            size: 3.39,
            url: '/uploads/binance_64d10b4b7d.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:07:22.000Z',
            updated_at: '2022-11-18T20:36:08.000Z',
        },
    },
    {
        id: 4,
        name: 'Bithumb',
        published_at: '2022-02-10T21:27:11.000Z',
        created_at: '2022-02-10T21:27:09.000Z',
        updated_at: '2022-10-21T08:16:34.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://en.bithumb.com/trade/order/XEC_KRW',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 30,
        trading_pairs: ['KRW'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: true,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 14,
            name: 'bithumb.png',
            alternativeText: 'Bithumb',
            caption: '',
            width: 634,
            height: 192,
            formats: {
                thumbnail: {
                    name: 'thumbnail_bithumb.png',
                    hash: 'thumbnail_bithumb_e7d49b0753',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 74,
                    size: 7.08,
                    path: null,
                    url: '/uploads/thumbnail_bithumb_e7d49b0753.png',
                },
                small: {
                    name: 'small_bithumb.png',
                    hash: 'small_bithumb_e7d49b0753',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 151,
                    size: 15.98,
                    path: null,
                    url: '/uploads/small_bithumb_e7d49b0753.png',
                },
            },
            hash: 'bithumb_e7d49b0753',
            ext: '.png',
            mime: 'image/png',
            size: 1.81,
            url: '/uploads/bithumb_e7d49b0753.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2022-10-21T08:16:31.000Z',
        },
    },
    {
        id: 5,
        name: 'CoinEx',
        published_at: '2022-02-10T23:16:37.000Z',
        created_at: '2022-02-10T23:16:34.000Z',
        updated_at: '2023-06-12T04:29:59.000Z',
        ecash_brand: true,
        decimal_places: 8,
        ecash_deposit_address_format: true,
        url: 'https://www.coinex.com/info/XEC',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT', 'USDC'],
        withdrawal_fee: 5,
        xec_withdrawal_fee: true,
        quirks_issues:
            "XEC/BTC pair needs to be added. They said they would figure out something for that but haven't given us an ETA. Also, they're requiring 120 confirmations to withdraw (and 20 to deposit) which seems like a lot.",
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 71,
            name: 'coinex.png',
            alternativeText: 'CoinEx',
            caption: '',
            width: 538,
            height: 173,
            formats: {
                thumbnail: {
                    name: 'thumbnail_coinex.png',
                    hash: 'thumbnail_coinex_7167e1c81d',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 79,
                    size: 8.13,
                    path: null,
                    url: '/uploads/thumbnail_coinex_7167e1c81d.png',
                },
                small: {
                    name: 'small_coinex.png',
                    hash: 'small_coinex_7167e1c81d',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 161,
                    size: 21.12,
                    path: null,
                    url: '/uploads/small_coinex_7167e1c81d.png',
                },
            },
            hash: 'coinex_7167e1c81d',
            ext: '.png',
            mime: 'image/png',
            size: 3.05,
            url: '/uploads/coinex_7167e1c81d.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-07-27T13:21:36.000Z',
            updated_at: '2022-10-21T08:22:59.000Z',
        },
    },
    {
        id: 8,
        name: 'Indodax',
        published_at: '2022-02-10T23:37:32.000Z',
        created_at: '2022-02-10T23:37:30.000Z',
        updated_at: '2022-11-15T13:28:40.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://indodax.com/market/XECUSDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['IDR'],
        logo: {
            id: 38,
            name: 'indodax.png',
            alternativeText: 'Indodax',
            caption: '',
            width: 500,
            height: 102,
            formats: {
                thumbnail: {
                    name: 'thumbnail_indodax.png',
                    hash: 'thumbnail_indodax_d61d9ee106',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 50,
                    size: 8.67,
                    path: null,
                    url: '/uploads/thumbnail_indodax_d61d9ee106.png',
                },
            },
            hash: 'indodax_d61d9ee106',
            ext: '.png',
            mime: 'image/png',
            size: 7.22,
            url: '/uploads/indodax_d61d9ee106.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:28:39.000Z',
        },
    },
    {
        id: 13,
        name: 'Hotbit',
        published_at: '2022-10-01T04:45:37.000Z',
        created_at: '2022-02-15T22:13:04.000Z',
        updated_at: '2022-12-09T11:42:34.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.hotbit.io/exchange?symbol=XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 2,
        trading_pairs: ['USDT'],
        withdrawal_fee: 5000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 35,
            name: 'hotbit.png',
            alternativeText: 'Hotbit',
            caption: '',
            width: 500,
            height: 138,
            formats: {
                thumbnail: {
                    name: 'thumbnail_hotbit.png',
                    hash: 'thumbnail_hotbit_3edd0cc911',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 68,
                    size: 6.19,
                    path: null,
                    url: '/uploads/thumbnail_hotbit_3edd0cc911.png',
                },
            },
            hash: 'hotbit_3edd0cc911',
            ext: '.png',
            mime: 'image/png',
            size: 4.56,
            url: '/uploads/hotbit_3edd0cc911.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:51.000Z',
            updated_at: '2022-10-21T08:27:19.000Z',
        },
    },
    {
        id: 14,
        name: 'Korbit',
        published_at: '2022-02-15T22:14:34.000Z',
        created_at: '2022-02-15T22:14:33.000Z',
        updated_at: '2022-10-21T08:29:22.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://exchange.korbit.co.kr/markets/?market=xec-krw',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 12,
        trading_pairs: ['KRW'],
        withdrawal_fee: 10000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 40,
            name: 'korbit.png',
            alternativeText: 'Korbit',
            caption: '',
            width: 500,
            height: 156,
            formats: {
                thumbnail: {
                    name: 'thumbnail_korbit.png',
                    hash: 'thumbnail_korbit_c7f68f9a00',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 76,
                    size: 6.34,
                    path: null,
                    url: '/uploads/thumbnail_korbit_c7f68f9a00.png',
                },
            },
            hash: 'korbit_c7f68f9a00',
            ext: '.png',
            mime: 'image/png',
            size: 3.5,
            url: '/uploads/korbit_c7f68f9a00.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:29:19.000Z',
        },
    },
    {
        id: 15,
        name: 'Bitfinex',
        published_at: '2022-02-15T22:16:26.000Z',
        created_at: '2022-02-15T22:16:25.000Z',
        updated_at: '2023-06-09T15:45:12.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://trading.bitfinex.com/t/XEC:USD',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USD'],
        withdrawal_fee: 0,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['USD', 'EUR', 'GBP', 'JPY', 'CNH'],
        logo: {
            id: 10,
            name: 'bitfinex.png',
            alternativeText: 'Bitfinex',
            caption: '',
            width: 422,
            height: 50,
            formats: {
                thumbnail: {
                    name: 'thumbnail_bitfinex.png',
                    hash: 'thumbnail_bitfinex_63accf2654',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 29,
                    size: 4.27,
                    path: null,
                    url: '/uploads/thumbnail_bitfinex_63accf2654.png',
                },
            },
            hash: 'bitfinex_63accf2654',
            ext: '.png',
            mime: 'image/png',
            size: 3.98,
            url: '/uploads/bitfinex_63accf2654.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2022-11-18T21:31:41.000Z',
        },
    },
    {
        id: 16,
        name: 'KUCOIN',
        published_at: '2022-02-15T22:18:15.000Z',
        created_at: '2022-02-15T22:18:13.000Z',
        updated_at: '2022-10-21T08:29:51.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://trade.kucoin.com/trade/XEC-USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 6,
        trading_pairs: ['USDT'],
        withdrawal_fee: 5000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 50,
            name: 'kucoin.png',
            alternativeText: 'KuCoin',
            caption: '',
            width: 600,
            height: 150,
            formats: {
                thumbnail: {
                    name: 'thumbnail_kucoin.png',
                    hash: 'thumbnail_kucoin_cbf360cb43',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 61,
                    size: 6.4,
                    path: null,
                    url: '/uploads/thumbnail_kucoin_cbf360cb43.png',
                },
                small: {
                    name: 'small_kucoin.png',
                    hash: 'small_kucoin_cbf360cb43',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 125,
                    size: 15.18,
                    path: null,
                    url: '/uploads/small_kucoin_cbf360cb43.png',
                },
            },
            hash: 'kucoin_cbf360cb43',
            ext: '.png',
            mime: 'image/png',
            size: 2.67,
            url: '/uploads/kucoin_cbf360cb43.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:29:48.000Z',
        },
    },
    {
        id: 17,
        name: 'UPbit',
        published_at: '2022-02-15T22:19:41.000Z',
        created_at: '2022-02-15T22:19:40.000Z',
        updated_at: '2022-10-21T08:33:29.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://upbit.com/exchange?code=CRIX.UPBIT.KRW-XEC',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 30,
        trading_pairs: ['KRW'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 57,
            name: 'upbit.png',
            alternativeText: 'UPBit',
            caption: '',
            width: 490,
            height: 154,
            formats: {
                thumbnail: {
                    name: 'thumbnail_upbit.png',
                    hash: 'thumbnail_upbit_098ce8e0b6',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 77,
                    size: 5.05,
                    path: null,
                    url: '/uploads/thumbnail_upbit_098ce8e0b6.png',
                },
            },
            hash: 'upbit_098ce8e0b6',
            ext: '.png',
            mime: 'image/png',
            size: 0.82,
            url: '/uploads/upbit_098ce8e0b6.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:33:27.000Z',
        },
    },
    {
        id: 18,
        name: 'LBank',
        published_at: '2022-02-15T22:21:38.000Z',
        created_at: '2022-02-15T22:21:37.000Z',
        updated_at: '2023-01-31T18:54:03.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.lbank.info/exchange/xec/usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1500,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 99,
            name: '189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
            alternativeText: '',
            caption: '',
            width: 2480,
            height: 704,
            formats: {
                thumbnail: {
                    name: 'thumbnail_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'thumbnail_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 70,
                    size: 5.36,
                    path: null,
                    url: '/uploads/thumbnail_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
                large: {
                    name: 'large_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'large_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 1000,
                    height: 284,
                    size: 23.64,
                    path: null,
                    url: '/uploads/large_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
                medium: {
                    name: 'medium_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'medium_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 213,
                    size: 17.08,
                    path: null,
                    url: '/uploads/medium_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
                small: {
                    name: 'small_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'small_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 142,
                    size: 11.01,
                    path: null,
                    url: '/uploads/small_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
            },
            hash: '189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
            ext: '.png',
            mime: 'image/png',
            size: 5.68,
            url: '/uploads/189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2023-01-31T06:55:12.000Z',
            updated_at: '2023-01-31T06:55:12.000Z',
        },
    },
    {
        id: 19,
        name: 'Poloniex',
        published_at: '2022-02-15T22:22:47.000Z',
        created_at: '2022-02-15T22:22:45.000Z',
        updated_at: '2022-10-21T08:32:37.000Z',
        ecash_brand: true,
        decimal_places: 8,
        ecash_deposit_address_format: true,
        url: 'https://poloniex.com/spot/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 10,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'Supports 40+ fiat currencies through Simplex payment partner',
        ],
        logo: {
            id: 76,
            name: 'poloniex_logo-freelogovectors.net_.png',
            alternativeText: 'Poloniex',
            caption: '',
            width: 1423,
            height: 365,
            formats: {
                thumbnail: {
                    name: 'thumbnail_poloniex_logo-freelogovectors.net_.png',
                    hash: 'thumbnail_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 63,
                    size: 6.65,
                    path: null,
                    url: '/uploads/thumbnail_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
                large: {
                    name: 'large_poloniex_logo-freelogovectors.net_.png',
                    hash: 'large_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 1000,
                    height: 257,
                    size: 29.92,
                    path: null,
                    url: '/uploads/large_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
                medium: {
                    name: 'medium_poloniex_logo-freelogovectors.net_.png',
                    hash: 'medium_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 192,
                    size: 21.87,
                    path: null,
                    url: '/uploads/medium_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
                small: {
                    name: 'small_poloniex_logo-freelogovectors.net_.png',
                    hash: 'small_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 128,
                    size: 14.21,
                    path: null,
                    url: '/uploads/small_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
            },
            hash: 'poloniex_logo_freelogovectors_net_f835d8039a',
            ext: '.png',
            mime: 'image/png',
            size: 4.76,
            url: '/uploads/poloniex_logo_freelogovectors_net_f835d8039a.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-08-18T06:25:06.000Z',
            updated_at: '2022-10-21T08:32:32.000Z',
        },
    },
    {
        id: 20,
        name: 'Huobi',
        published_at: '2023-01-10T21:27:20.000Z',
        created_at: '2022-02-15T22:33:53.000Z',
        updated_at: '2023-01-10T21:27:20.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://www.huobi.com/en-in/exchange/xec_usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: "Don't want to use the new address format",
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['60+ Currencies through Visa/Mastercard'],
        logo: {
            id: 37,
            name: 'huobi.png',
            alternativeText: 'Huobi',
            caption: '',
            width: 500,
            height: 152,
            formats: {
                thumbnail: {
                    name: 'thumbnail_huobi.png',
                    hash: 'thumbnail_huobi_cfbdcdb9d7',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 74,
                    size: 6.73,
                    path: null,
                    url: '/uploads/thumbnail_huobi_cfbdcdb9d7.png',
                },
            },
            hash: 'huobi_cfbdcdb9d7',
            ext: '.png',
            mime: 'image/png',
            size: 4.66,
            url: '/uploads/huobi_cfbdcdb9d7.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:28:20.000Z',
        },
    },
    {
        id: 21,
        name: 'MEXC',
        published_at: '2022-02-15T22:38:47.000Z',
        created_at: '2022-02-15T22:38:45.000Z',
        updated_at: '2023-02-16T08:53:26.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://www.mexc.com/exchange/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 2,
        trading_pairs: ['USDT'],
        withdrawal_fee: 2000,
        xec_withdrawal_fee: null,
        quirks_issues: 'Using legacy (BTC) address format for deposits',
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'AED',
            'AUD',
            'BDT',
            'BRL',
            'CAD',
            'EGP',
            'EUR',
            'GBP',
            'GHS',
            'IDR',
            'INR',
            'JPY',
            'KRW',
            'KZT',
            'MYR',
            'MMK',
            'TWD',
            'NGN',
            'PHP',
            'PKR',
            'RUB',
            'TZS',
            'THB',
            'TRY',
            'UAH',
            'USD',
            'VES',
            'VND',
        ],
        logo: {
            id: 55,
            name: 'mexc.png',
            alternativeText: 'MEXC',
            caption: '',
            width: 1586,
            height: 356,
            formats: {
                thumbnail: {
                    name: 'thumbnail_mexc.png',
                    hash: 'thumbnail_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 55,
                    size: 7.82,
                    path: null,
                    url: '/uploads/thumbnail_mexc_f3083ac0c3.png',
                },
                large: {
                    name: 'large_mexc.png',
                    hash: 'large_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 1000,
                    height: 224,
                    size: 42.92,
                    path: null,
                    url: '/uploads/large_mexc_f3083ac0c3.png',
                },
                medium: {
                    name: 'medium_mexc.png',
                    hash: 'medium_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 168,
                    size: 32.96,
                    path: null,
                    url: '/uploads/medium_mexc_f3083ac0c3.png',
                },
                small: {
                    name: 'small_mexc.png',
                    hash: 'small_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 112,
                    size: 19.21,
                    path: null,
                    url: '/uploads/small_mexc_f3083ac0c3.png',
                },
            },
            hash: 'mexc_f3083ac0c3',
            ext: '.png',
            mime: 'image/png',
            size: 6.34,
            url: '/uploads/mexc_f3083ac0c3.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:31:31.000Z',
        },
    },
    {
        id: 23,
        name: 'Ascendex',
        published_at: '2022-02-15T23:26:01.000Z',
        created_at: '2022-02-15T23:25:59.000Z',
        updated_at: '2022-10-21T08:13:43.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: false,
        url: 'https://ascendex.com/en/cashtrade-spottrading/usdt/xec',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 15,
        trading_pairs: ['USDT'],
        withdrawal_fee: 10000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'AED',
            'ARS',
            'AUD',
            'AZN',
            'BGN',
            'BRL',
            'CAD',
            'CHF',
            'CLP',
            'COP',
            'CRC',
            'CZK',
            'DKK',
            'DOP',
            'EGP',
            'EUR',
            'GBP',
            'GEL',
            'GHS',
            'HKD',
            'HRK',
            'HUF',
            'IDR',
            'ILS',
            'INR',
            'JOD',
            'JPY',
            'KES',
            'KRW',
            'KWD',
            'KZT',
            'LKR',
            'MDL',
            'MXN',
            'MYR',
            'NAD',
            'NGN',
            'NOK',
            'NZD',
            'OMR',
            'PEN',
            'PHP',
            'PKR',
            'PLN',
            'QAR',
            'RON',
            'RUB',
            'SAR',
            'SEK',
            'SGD',
            'THB',
            'TRY',
            'TWD',
            'TZS',
            'UAH',
            'UGX',
            'USD',
            'UYU',
            'UZS',
            'VND',
            'ZAR',
        ],
        logo: {
            id: 5,
            name: 'ascendex.png',
            alternativeText: '',
            caption: '',
            width: 500,
            height: 100,
            formats: {
                thumbnail: {
                    name: 'thumbnail_ascendex.png',
                    hash: 'thumbnail_ascendex_68ea0e377c',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 49,
                    size: 5.81,
                    path: null,
                    url: '/uploads/thumbnail_ascendex_68ea0e377c.png',
                },
            },
            hash: 'ascendex_68ea0e377c',
            ext: '.png',
            mime: 'image/png',
            size: 4.92,
            url: '/uploads/ascendex_68ea0e377c.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:49.000Z',
            updated_at: '2022-10-21T08:15:24.000Z',
        },
    },
    {
        id: 24,
        name: 'Coinone',
        published_at: '2022-02-15T23:27:21.000Z',
        created_at: '2022-02-15T23:27:20.000Z',
        updated_at: '2022-10-21T08:23:22.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://coinone.co.kr/exchange/trade/xec/krw',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 10,
        trading_pairs: ['KRW'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 26,
            name: 'coinone.png',
            alternativeText: 'Coinone',
            caption: '',
            width: 664,
            height: 130,
            formats: {
                thumbnail: {
                    name: 'thumbnail_coinone.png',
                    hash: 'thumbnail_coinone_d6e3fa4fd3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 48,
                    size: 6.08,
                    path: null,
                    url: '/uploads/thumbnail_coinone_d6e3fa4fd3.png',
                },
                small: {
                    name: 'small_coinone.png',
                    hash: 'small_coinone_d6e3fa4fd3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 98,
                    size: 14.44,
                    path: null,
                    url: '/uploads/small_coinone_d6e3fa4fd3.png',
                },
            },
            hash: 'coinone_d6e3fa4fd3',
            ext: '.png',
            mime: 'image/png',
            size: 3.55,
            url: '/uploads/coinone_d6e3fa4fd3.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:51.000Z',
            updated_at: '2022-10-21T08:23:19.000Z',
        },
    },
    {
        id: 25,
        name: 'gate.io',
        published_at: '2022-02-15T23:28:48.000Z',
        created_at: '2022-02-15T23:28:47.000Z',
        updated_at: '2023-04-22T01:30:59.000Z',
        ecash_brand: true,
        decimal_places: 3,
        ecash_deposit_address_format: true,
        url: 'https://www.gate.io/tw/trade/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 6,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['CNY', 'KRW', 'VND', 'USD', 'INR', 'TRY'],
        logo: {
            id: 73,
            name: 'gate-io.png',
            alternativeText: '',
            caption: '',
            width: 400,
            height: 100,
            formats: {
                thumbnail: {
                    name: 'thumbnail_gate-io.png',
                    hash: 'thumbnail_gate_io_793eef8007',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 61,
                    size: 7.01,
                    path: null,
                    url: '/uploads/thumbnail_gate_io_793eef8007.png',
                },
            },
            hash: 'gate_io_793eef8007',
            ext: '.png',
            mime: 'image/png',
            size: 3.07,
            url: '/uploads/gate_io_793eef8007.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-07-27T13:28:57.000Z',
            updated_at: '2022-10-21T08:26:54.000Z',
        },
    },
    {
        id: 27,
        name: 'OKX',
        published_at: '2022-02-15T23:31:12.000Z',
        created_at: '2022-02-15T23:31:11.000Z',
        updated_at: '2023-04-17T05:40:00.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.okex.com/markets/prices/ecash-xec',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 30,
        trading_pairs: ['USDT'],
        withdrawal_fee: 800,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'Supports 90+ fiat currencies via credit card/debit card/wire transfer/paypal and more.',
        ],
        logo: {
            id: 43,
            name: 'okx.png',
            alternativeText: 'OKX',
            caption: '',
            width: 164,
            height: 72,
            formats: {},
            hash: 'okx_59b3b0c033',
            ext: '.png',
            mime: 'image/png',
            size: 0.22,
            url: '/uploads/okx_59b3b0c033.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:31:45.000Z',
        },
    },
    {
        id: 30,
        name: 'BKEX',
        published_at: '2022-02-15T23:36:07.000Z',
        created_at: '2022-02-15T23:36:05.000Z',
        updated_at: '2022-11-18T21:32:10.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.bkex.com/trade/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 60,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['THB'],
        logo: {
            id: 15,
            name: 'bkex.png',
            alternativeText: 'Bkex',
            caption: '',
            width: 168,
            height: 48,
            formats: {},
            hash: 'bkex_1f3d977204',
            ext: '.png',
            mime: 'image/png',
            size: 1.32,
            url: '/uploads/bkex_1f3d977204.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2023-02-17T07:35:36.000Z',
        },
    },
    {
        id: 33,
        name: 'SouthXchange',
        published_at: '2022-02-15T23:45:53.000Z',
        created_at: '2022-02-15T23:45:52.000Z',
        updated_at: '2022-12-21T05:54:25.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://main.southxchange.com/Market/Book/XEC/BTC',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['BTC'],
        withdrawal_fee: 3,
        xec_withdrawal_fee: null,
        quirks_issues:
            'We will enable deposits and withdrawals when we have a free server available to run the wallet. If you are able to sponsor a server then we can enable it asap. Otherwise it might take some time.',
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 48,
            name: 'southxchange.png',
            alternativeText: 'southXchange',
            caption: '',
            width: 334,
            height: 80,
            formats: {
                thumbnail: {
                    name: 'thumbnail_southxchange.png',
                    hash: 'thumbnail_southxchange_503b223a1e',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 59,
                    size: 6.08,
                    path: null,
                    url: '/uploads/thumbnail_southxchange_503b223a1e.png',
                },
            },
            hash: 'southxchange_503b223a1e',
            ext: '.png',
            mime: 'image/png',
            size: 2.17,
            url: '/uploads/southxchange_503b223a1e.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:32:52.000Z',
        },
    },
    {
        id: 34,
        name: 'Bybit',
        published_at: '2022-02-15T23:47:02.000Z',
        created_at: '2022-02-15T23:47:00.000Z',
        updated_at: '2022-10-21T08:22:39.000Z',
        ecash_brand: true,
        decimal_places: 1,
        ecash_deposit_address_format: false,
        url: 'https://www.bybit.com/trade/spot/XEC/USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 60,
        trading_pairs: ['USDT'],
        withdrawal_fee: 10000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 18,
            name: 'bybit.png',
            alternativeText: 'Bybit',
            caption: '',
            width: 767,
            height: 266,
            formats: {
                thumbnail: {
                    name: 'thumbnail_bybit.png',
                    hash: 'thumbnail_bybit_303e7734d1',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 85,
                    size: 4.97,
                    path: null,
                    url: '/uploads/thumbnail_bybit_303e7734d1.png',
                },
                medium: {
                    name: 'medium_bybit.png',
                    hash: 'medium_bybit_303e7734d1',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 260,
                    size: 16.96,
                    path: null,
                    url: '/uploads/medium_bybit_303e7734d1.png',
                },
                small: {
                    name: 'small_bybit.png',
                    hash: 'small_bybit_303e7734d1',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 173,
                    size: 10.32,
                    path: null,
                    url: '/uploads/small_bybit_303e7734d1.png',
                },
            },
            hash: 'bybit_303e7734d1',
            ext: '.png',
            mime: 'image/png',
            size: 3.66,
            url: '/uploads/bybit_303e7734d1.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2022-10-21T08:22:33.000Z',
        },
    },
    {
        id: 35,
        name: 'HitBTC',
        published_at: '2022-11-11T06:40:56.000Z',
        created_at: '2022-02-15T23:48:16.000Z',
        updated_at: '2022-11-21T23:29:30.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: false,
        url: 'https://hitbtc.com/xec-to-usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 10,
        trading_pairs: ['BTC', 'USDT'],
        withdrawal_fee: 150000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 31,
            name: 'hitbtc.png',
            alternativeText: '',
            caption: '',
            width: 400,
            height: 184,
            formats: {
                thumbnail: {
                    name: 'thumbnail_hitbtc.png',
                    hash: 'thumbnail_hitbtc_7016491270',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 113,
                    size: 9.34,
                    path: null,
                    url: '/uploads/thumbnail_hitbtc_7016491270.png',
                },
            },
            hash: 'hitbtc_7016491270',
            ext: '.png',
            mime: 'image/png',
            size: 10.19,
            url: '/uploads/hitbtc_7016491270.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:51.000Z',
            updated_at: '2022-02-10T21:24:51.000Z',
        },
    },
    {
        id: 40,
        name: 'Hotcoin',
        published_at: '2022-09-17T01:55:47.000Z',
        created_at: '2022-06-23T05:44:32.000Z',
        updated_at: '2022-11-18T21:33:12.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.hotcoin.com/currencyExchange/xec_usdt',
        deposits_working: false,
        withdrawals_working: false,
        deposit_confirmations: 11,
        trading_pairs: ['USDT'],
        withdrawal_fee: null,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'CNY',
            'USD',
            'EUR',
            'GBP',
            'AED',
            'AMD',
            'ARS',
            'AUD',
            'BDT',
            'BHD',
            'BND',
            'BOB',
            'RSL',
            'CAD',
            'CLP',
            'COP',
            'DOP',
            'EGP',
            'GHS',
            'HKD',
            'IDR',
            'INR',
            'JPY',
            'KES',
            'KHR',
            'KWD',
            'KZT',
            'LAK',
            'LKR',
            'MAD',
            'MMK',
            'MNT',
            'MXN',
            'NGN',
            'NPR',
            'PAB',
            'PEN',
            'PHP',
            'PKR',
            'PLN',
            'PYG',
            'RON',
            'RUB',
            'VND',
            'THB',
            'TRY',
        ],
        logo: {
            id: 78,
            name: 'hotcoin logo-1.png',
            alternativeText: 'Hotcoin',
            caption: '',
            width: 334,
            height: 50,
            formats: {
                thumbnail: {
                    name: 'thumbnail_hotcoin logo-1.png',
                    hash: 'thumbnail_hotcoin_logo_1_7cd6c68edc',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 37,
                    size: 5.14,
                    path: null,
                    url: '/uploads/thumbnail_hotcoin_logo_1_7cd6c68edc.png',
                },
            },
            hash: 'hotcoin_logo_1_7cd6c68edc',
            ext: '.png',
            mime: 'image/png',
            size: 3.63,
            url: '/uploads/hotcoin_logo_1_7cd6c68edc.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-09-17T01:00:35.000Z',
            updated_at: '2022-11-18T21:33:09.000Z',
        },
    },
    {
        id: 41,
        name: 'Bitrue',
        published_at: '2022-08-05T18:33:31.000Z',
        created_at: '2022-08-05T18:23:47.000Z',
        updated_at: '2022-12-08T06:43:36.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.bitrue.com/trade/xec_usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 82,
            name: 'Bitrue_44093e2318.png',
            alternativeText: '',
            caption: '',
            width: 597,
            height: 163,
            formats: {
                thumbnail: {
                    name: 'thumbnail_Bitrue_44093e2318.png',
                    hash: 'thumbnail_Bitrue_44093e2318_ef5bb48b0b',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 67,
                    size: 7.28,
                    path: null,
                    url: '/uploads/thumbnail_Bitrue_44093e2318_ef5bb48b0b.png',
                },
                small: {
                    name: 'small_Bitrue_44093e2318.png',
                    hash: 'small_Bitrue_44093e2318_ef5bb48b0b',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 137,
                    size: 17.07,
                    path: null,
                    url: '/uploads/small_Bitrue_44093e2318_ef5bb48b0b.png',
                },
            },
            hash: 'Bitrue_44093e2318_ef5bb48b0b',
            ext: '.png',
            mime: 'image/png',
            size: 4.98,
            url: '/uploads/Bitrue_44093e2318_ef5bb48b0b.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-10-21T08:17:27.000Z',
            updated_at: '2022-10-21T08:17:27.000Z',
        },
    },
    {
        id: 43,
        name: 'FMFW.io',
        published_at: '2022-11-14T10:26:44.000Z',
        created_at: '2022-11-14T09:00:15.000Z',
        updated_at: '2022-12-16T13:14:19.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://fmfw.io/xec-to-usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 5,
        trading_pairs: ['USDT', 'BTC'],
        withdrawal_fee: 8660,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 86,
            name: 'IMG_20221114_175356_215.png',
            alternativeText: '',
            caption: '',
            width: 234,
            height: 50,
            formats: {},
            hash: 'IMG_20221114_175356_215_607f24f2e2',
            ext: '.png',
            mime: 'image/png',
            size: 2.86,
            url: '/uploads/IMG_20221114_175356_215_607f24f2e2.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-11-14T08:55:16.000Z',
            updated_at: '2022-11-18T21:19:47.000Z',
        },
    },
    {
        id: 45,
        name: 'XT.com',
        published_at: '2022-11-30T20:14:13.000Z',
        created_at: '2022-11-29T06:28:27.000Z',
        updated_at: '2022-11-30T20:14:13.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: null,
        url: 'https://www.xt.com/tradePro/xec_usdt',
        deposits_working: false,
        withdrawals_working: false,
        deposit_confirmations: null,
        trading_pairs: ['USDT'],
        withdrawal_fee: null,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 92,
            name: 'xt_com_logo-freelogovectors.net_.png',
            alternativeText: '',
            caption: '',
            width: 320,
            height: 92,
            formats: {
                thumbnail: {
                    name: 'thumbnail_xt_com_logo-freelogovectors.net_.png',
                    hash: 'thumbnail_xt_com_logo_freelogovectors_net_274dddb9b6',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 70,
                    size: 7.3,
                    path: null,
                    url: '/uploads/thumbnail_xt_com_logo_freelogovectors_net_274dddb9b6.png',
                },
            },
            hash: 'xt_com_logo_freelogovectors_net_274dddb9b6',
            ext: '.png',
            mime: 'image/png',
            size: 7.65,
            url: '/uploads/xt_com_logo_freelogovectors_net_274dddb9b6.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-11-29T06:34:39.000Z',
            updated_at: '2022-11-29T06:34:39.000Z',
        },
    },
    {
        id: 46,
        name: 'Bitbarg ',
        published_at: '2022-12-21T19:39:01.000Z',
        created_at: '2022-12-21T18:49:54.000Z',
        updated_at: '2022-12-22T03:05:47.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://bitbarg.com/',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 6,
        trading_pairs: ['IRR'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['IRR'],
        logo: {
            id: 95,
            name: 'Bitbarg.svg',
            alternativeText: '',
            caption: '',
            width: 209,
            height: 68,
            formats: null,
            hash: 'Bitbarg_0b2e57f56e',
            ext: '.svg',
            mime: 'image/svg+xml',
            size: 4.94,
            url: '/uploads/Bitbarg_0b2e57f56e.svg',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-12-21T19:41:05.000Z',
            updated_at: '2022-12-21T19:41:05.000Z',
        },
    },
];

export const mockInstantExchanges = [
    {
        id: 1,
        name: 'StealthEX',
        published_at: '2022-02-16T03:28:45.000Z',
        created_at: '2022-02-16T03:28:43.000Z',
        updated_at: '2022-10-21T11:13:10.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 8,
        ecash_deposit_address_format: true,
        url: 'https://stealthex.io/coin/xec',
        logo: [
            {
                id: 54,
                name: 'stealthex.png',
                alternativeText: 'StealthEX',
                caption: '',
                width: 793,
                height: 148,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_stealthex.png',
                        hash: 'thumbnail_stealthex_691f504038',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 46,
                        size: 6.33,
                        path: null,
                        url: '/uploads/thumbnail_stealthex_691f504038.png',
                    },
                    medium: {
                        name: 'medium_stealthex.png',
                        hash: 'medium_stealthex_691f504038',
                        ext: '.png',
                        mime: 'image/png',
                        width: 750,
                        height: 140,
                        size: 21.64,
                        path: null,
                        url: '/uploads/medium_stealthex_691f504038.png',
                    },
                    small: {
                        name: 'small_stealthex.png',
                        hash: 'small_stealthex_691f504038',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 93,
                        size: 13.83,
                        path: null,
                        url: '/uploads/small_stealthex_691f504038.png',
                    },
                },
                hash: 'stealthex_691f504038',
                ext: '.png',
                mime: 'image/png',
                size: 3.94,
                url: '/uploads/stealthex_691f504038.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-10-21T11:13:09.000Z',
            },
        ],
    },
    {
        id: 2,
        name: 'Godex',
        published_at: '2022-02-16T03:31:42.000Z',
        created_at: '2022-02-16T03:31:40.000Z',
        updated_at: '2022-10-21T11:12:31.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 8,
        ecash_deposit_address_format: true,
        url: 'https://godex.io/exchange?coin_from=USDT&coin_to=XEC&amount=500',
        logo: [
            {
                id: 27,
                name: 'godex.png',
                alternativeText: 'Godex',
                caption: '',
                width: 400,
                height: 106,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_godex.png',
                        hash: 'thumbnail_godex_c43971ace3',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 65,
                        size: 5.59,
                        path: null,
                        url: '/uploads/thumbnail_godex_c43971ace3.png',
                    },
                },
                hash: 'godex_c43971ace3',
                ext: '.png',
                mime: 'image/png',
                size: 2.27,
                url: '/uploads/godex_c43971ace3.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:12:30.000Z',
            },
        ],
    },
    {
        id: 3,
        name: 'SimpleSwap',
        published_at: '2022-02-16T03:32:23.000Z',
        created_at: '2022-02-16T03:32:18.000Z',
        updated_at: '2022-10-21T11:12:58.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 8,
        ecash_deposit_address_format: false,
        url: 'https://simpleswap.io/?to=xec',
        logo: [
            {
                id: 49,
                name: 'simpleswap.png',
                alternativeText: 'SimpleSwap',
                caption: '',
                width: 400,
                height: 77,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_simpleswap.png',
                        hash: 'thumbnail_simpleswap_5e3be28a36',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 47,
                        size: 6.38,
                        path: null,
                        url: '/uploads/thumbnail_simpleswap_5e3be28a36.png',
                    },
                },
                hash: 'simpleswap_5e3be28a36',
                ext: '.png',
                mime: 'image/png',
                size: 3.11,
                url: '/uploads/simpleswap_5e3be28a36.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-10-21T11:12:56.000Z',
            },
        ],
    },
    {
        id: 4,
        name: 'Change Now',
        published_at: '2022-08-11T00:42:44.000Z',
        created_at: '2022-08-11T00:41:43.000Z',
        updated_at: '2022-10-21T11:12:13.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: null,
        decimal_place: null,
        ecash_deposit_address_format: true,
        url: 'https://changenow.io/?from=xec&to=usdttrc20',
        logo: [
            {
                id: 75,
                name: 'change-now.png',
                alternativeText: 'ChangeNOW',
                caption: '',
                width: 213,
                height: 150,
                formats: {},
                hash: 'change_now_fde3e4f2fa',
                ext: '.png',
                mime: 'image/png',
                size: 3.31,
                url: '/uploads/change_now_fde3e4f2fa.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-08-11T00:41:04.000Z',
                updated_at: '2022-10-21T11:12:11.000Z',
            },
        ],
    },
    {
        id: 5,
        name: 'LetsExchange',
        published_at: '2022-09-16T20:27:49.000Z',
        created_at: '2022-09-16T20:27:38.000Z',
        updated_at: '2023-06-07T22:48:57.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: null,
        decimal_place: 8,
        ecash_deposit_address_format: true,
        url: 'https://letsexchange.io/',
        logo: [
            {
                id: 77,
                name: 'letsexchange.png',
                alternativeText: 'LetsExchange',
                caption: '',
                width: 380,
                height: 50,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_letsexchange.png',
                        hash: 'thumbnail_letsexchange_9a542bc886',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 32,
                        size: 5.52,
                        path: null,
                        url: '/uploads/thumbnail_letsexchange_9a542bc886.png',
                    },
                },
                hash: 'letsexchange_9a542bc886',
                ext: '.png',
                mime: 'image/png',
                size: 5.34,
                url: '/uploads/letsexchange_9a542bc886.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-09-16T20:25:25.000Z',
                updated_at: '2022-11-18T21:33:32.000Z',
            },
        ],
    },
    {
        id: 6,
        name: 'EasyBit',
        published_at: '2022-10-21T22:56:40.000Z',
        created_at: '2022-10-21T22:50:10.000Z',
        updated_at: '2022-11-16T05:17:46.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 2,
        ecash_deposit_address_format: true,
        url: 'https://easybit.com/en/exchange#xec',
        logo: [
            {
                id: 85,
                name: 'EasyBit-logo.png',
                alternativeText: '',
                caption: '',
                width: 320,
                height: 86,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_EasyBit-logo.png',
                        hash: 'thumbnail_Easy_Bit_logo_342eaf5425',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 66,
                        size: 6.69,
                        path: null,
                        url: '/uploads/thumbnail_Easy_Bit_logo_342eaf5425.png',
                    },
                },
                hash: 'Easy_Bit_logo_342eaf5425',
                ext: '.png',
                mime: 'image/png',
                size: 3.2,
                url: '/uploads/Easy_Bit_logo_342eaf5425.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-10-21T22:58:36.000Z',
                updated_at: '2022-10-21T22:58:36.000Z',
            },
        ],
    },
    {
        id: 7,
        name: 'Changelly',
        published_at: '2023-01-10T12:02:41.000Z',
        created_at: '2023-01-10T12:00:45.000Z',
        updated_at: '2023-02-20T10:58:21.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 10,
        decimal_place: 2,
        ecash_deposit_address_format: true,
        url: 'https://changelly.com/?from=btc&to=xec&utm_medium=social&utm_source=twitter&utm_campaign=listing',
        logo: [
            {
                id: 96,
                name: 'horizontal-changelly-logo-4.png',
                alternativeText: '',
                caption: '',
                width: 770,
                height: 200,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_horizontal-changelly-logo-4.png',
                        hash: 'thumbnail_horizontal_changelly_logo_4_d605d09204',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 64,
                        size: 7.13,
                        path: null,
                        url: '/uploads/thumbnail_horizontal_changelly_logo_4_d605d09204.png',
                    },
                    medium: {
                        name: 'medium_horizontal-changelly-logo-4.png',
                        hash: 'medium_horizontal_changelly_logo_4_d605d09204',
                        ext: '.png',
                        mime: 'image/png',
                        width: 750,
                        height: 195,
                        size: 31.59,
                        path: null,
                        url: '/uploads/medium_horizontal_changelly_logo_4_d605d09204.png',
                    },
                    small: {
                        name: 'small_horizontal-changelly-logo-4.png',
                        hash: 'small_horizontal_changelly_logo_4_d605d09204',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 130,
                        size: 18.56,
                        path: null,
                        url: '/uploads/small_horizontal_changelly_logo_4_d605d09204.png',
                    },
                },
                hash: 'horizontal_changelly_logo_4_d605d09204',
                ext: '.png',
                mime: 'image/png',
                size: 10.92,
                url: '/uploads/horizontal_changelly_logo_4_d605d09204.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-01-10T12:02:36.000Z',
                updated_at: '2023-01-10T12:02:36.000Z',
            },
        ],
    },
    {
        id: 8,
        name: 'Quickex',
        published_at: '2023-06-12T04:18:18.000Z',
        created_at: '2023-06-12T04:18:07.000Z',
        updated_at: '2023-06-12T04:18:30.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 1,
        decimal_place: 6,
        ecash_deposit_address_format: true,
        url: 'https://quickex.io/exchange-xec-usdt',
        logo: [
            {
                id: 117,
                name: 'Quickex.png',
                alternativeText: '',
                caption: '',
                width: 458,
                height: 138,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_Quickex.png',
                        hash: 'thumbnail_Quickex_bfc370a633',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 74,
                        size: 7.82,
                        path: null,
                        url: '/uploads/thumbnail_Quickex_bfc370a633.png',
                    },
                },
                hash: 'Quickex_bfc370a633',
                ext: '.png',
                mime: 'image/png',
                size: 5.12,
                url: '/uploads/Quickex_bfc370a633.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-06-12T04:15:09.000Z',
                updated_at: '2023-06-12T04:15:09.000Z',
            },
        ],
    },
];

export const mockServices = [
    {
        id: 1,
        name: 'be.cash',
        url: 'https://explorer.be.cash/blocks',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:13:05.000Z',
        created_at: '2022-02-16T19:13:04.000Z',
        updated_at: '2022-10-21T11:08:42.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 7,
                name: 'be-cash.png',
                alternativeText: 'be.cash',
                caption: '',
                width: 518,
                height: 205,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_be-cash.png',
                        hash: 'thumbnail_be_cash_aa364bfcb7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 97,
                        size: 7.3,
                        path: null,
                        url: '/uploads/thumbnail_be_cash_aa364bfcb7.png',
                    },
                    small: {
                        name: 'small_be-cash.png',
                        hash: 'small_be_cash_aa364bfcb7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 198,
                        size: 18.35,
                        path: null,
                        url: '/uploads/small_be_cash_aa364bfcb7.png',
                    },
                },
                hash: 'be_cash_aa364bfcb7',
                ext: '.png',
                mime: 'image/png',
                size: 4.95,
                url: '/uploads/be_cash_aa364bfcb7.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:49.000Z',
                updated_at: '2022-10-21T11:08:39.000Z',
            },
        ],
    },
    {
        id: 2,
        name: 'Blockchair',
        url: 'https://blockchair.com/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: "Stating that more than 1 confirmation is required for finalization and using 'ECash' instead of 'eCash' on the tooltip.",
        published_at: '2022-02-16T19:14:56.000Z',
        created_at: '2022-02-16T19:14:50.000Z',
        updated_at: '2022-10-21T11:10:00.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 12,
                name: 'blockchair.png',
                alternativeText: 'Blockchair',
                caption: '',
                width: 500,
                height: 134,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_blockchair.png',
                        hash: 'thumbnail_blockchair_d20f851724',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 66,
                        size: 5.27,
                        path: null,
                        url: '/uploads/thumbnail_blockchair_d20f851724.png',
                    },
                },
                hash: 'blockchair_d20f851724',
                ext: '.png',
                mime: 'image/png',
                size: 3.24,
                url: '/uploads/blockchair_d20f851724.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:50.000Z',
                updated_at: '2022-10-21T11:09:58.000Z',
            },
        ],
    },
    {
        id: 3,
        name: 'Coin Dance',
        url: 'https://ecash.coin.dance/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-07-27T13:22:25.000Z',
        created_at: '2022-02-16T19:15:36.000Z',
        updated_at: '2022-10-21T11:10:28.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 72,
                name: 'coin-dance.png',
                alternativeText: 'Coin Dance',
                caption: '',
                width: 500,
                height: 102,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coin-dance.png',
                        hash: 'thumbnail_coin_dance_e17caff117',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 50,
                        size: 4.78,
                        path: null,
                        url: '/uploads/thumbnail_coin_dance_e17caff117.png',
                    },
                },
                hash: 'coin_dance_e17caff117',
                ext: '.png',
                mime: 'image/png',
                size: 2.21,
                url: '/uploads/coin_dance_e17caff117.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-07-27T13:24:41.000Z',
                updated_at: '2022-10-21T11:10:26.000Z',
            },
        ],
    },
    {
        id: 4,
        name: 'CoinGecko',
        url: 'https://www.coingecko.com/en/coins/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:16:19.000Z',
        created_at: '2022-02-16T19:16:18.000Z',
        updated_at: '2022-10-21T11:10:58.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 21,
                name: 'coingecko.png',
                alternativeText: 'CoinGecko',
                caption: '',
                width: 500,
                height: 151,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coingecko.png',
                        hash: 'thumbnail_coingecko_7d6f520f55',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 74,
                        size: 7.1,
                        path: null,
                        url: '/uploads/thumbnail_coingecko_7d6f520f55.png',
                    },
                },
                hash: 'coingecko_7d6f520f55',
                ext: '.png',
                mime: 'image/png',
                size: 5.16,
                url: '/uploads/coingecko_7d6f520f55.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:10:56.000Z',
            },
        ],
    },
    {
        id: 5,
        name: 'CoinMarketCap',
        url: 'https://coinmarketcap.com/currencies/ecash/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:17:20.000Z',
        created_at: '2022-02-16T19:17:18.000Z',
        updated_at: '2022-10-21T11:11:13.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 22,
                name: 'coinmarketcap.png',
                alternativeText: 'CoinMarketCap',
                caption: '',
                width: 500,
                height: 98,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coinmarketcap.png',
                        hash: 'thumbnail_coinmarketcap_86fb1e6629',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 48,
                        size: 5.71,
                        path: null,
                        url: '/uploads/thumbnail_coinmarketcap_86fb1e6629.png',
                    },
                },
                hash: 'coinmarketcap_86fb1e6629',
                ext: '.png',
                mime: 'image/png',
                size: 4.16,
                url: '/uploads/coinmarketcap_86fb1e6629.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:11:10.000Z',
            },
        ],
    },
    {
        id: 6,
        name: 'Livecoinwatch',
        url: 'https://www.livecoinwatch.com/price/eCash-XEC',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:17:59.000Z',
        created_at: '2022-02-16T19:17:59.000Z',
        updated_at: '2022-10-21T11:11:53.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 52,
                name: 'livecoinwatch.png',
                alternativeText: 'Live Coin Watch',
                caption: '',
                width: 600,
                height: 77,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_livecoinwatch.png',
                        hash: 'thumbnail_livecoinwatch_3fec7e3a6c',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 31,
                        size: 4.36,
                        path: null,
                        url: '/uploads/thumbnail_livecoinwatch_3fec7e3a6c.png',
                    },
                    small: {
                        name: 'small_livecoinwatch.png',
                        hash: 'small_livecoinwatch_3fec7e3a6c',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 64,
                        size: 10.82,
                        path: null,
                        url: '/uploads/small_livecoinwatch_3fec7e3a6c.png',
                    },
                },
                hash: 'livecoinwatch_3fec7e3a6c',
                ext: '.png',
                mime: 'image/png',
                size: 4.01,
                url: '/uploads/livecoinwatch_3fec7e3a6c.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-10-21T11:11:50.000Z',
            },
        ],
    },
    {
        id: 7,
        name: 'feixiaohao.com',
        url: 'https://www.feixiaohaozh.info/currencies/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: '',
        published_at: '2022-02-16T19:19:21.000Z',
        created_at: '2022-02-16T19:19:20.000Z',
        updated_at: '2023-06-09T05:40:22.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 25,
                name: 'feixiaohao-com.png',
                alternativeText: 'feixiaohao',
                caption: '',
                width: 500,
                height: 120,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_feixiaohao-com.png',
                        hash: 'thumbnail_feixiaohao_com_b8f00e03d7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 59,
                        size: 5.62,
                        path: null,
                        url: '/uploads/thumbnail_feixiaohao_com_b8f00e03d7.png',
                    },
                },
                hash: 'feixiaohao_com_b8f00e03d7',
                ext: '.png',
                mime: 'image/png',
                size: 2.91,
                url: '/uploads/feixiaohao_com_b8f00e03d7.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:11:32.000Z',
            },
        ],
    },
    {
        id: 8,
        name: 'ViaWallet Explorer',
        url: 'https://explorer.viawallet.com/xec',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 8,
        issues: null,
        published_at: '2022-02-16T19:20:45.000Z',
        created_at: '2022-02-16T19:20:13.000Z',
        updated_at: '2022-02-16T19:20:45.000Z',
        fiat_deposit_options: null,
        logo: [
            {
                id: 58,
                name: 'viawallet-explorer.png',
                alternativeText: '',
                caption: '',
                width: 400,
                height: 84,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_viawallet-explorer.png',
                        hash: 'thumbnail_viawallet_explorer_36e2f5944b',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 51,
                        size: 6.99,
                        path: null,
                        url: '/uploads/thumbnail_viawallet_explorer_36e2f5944b.png',
                    },
                },
                hash: 'viawallet_explorer_36e2f5944b',
                ext: '.png',
                mime: 'image/png',
                size: 6.63,
                url: '/uploads/viawallet_explorer_36e2f5944b.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-02-10T21:24:53.000Z',
            },
        ],
    },
    {
        id: 9,
        name: 'CoinCap.io',
        url: 'https://coincap.io/assets/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: null,
        issues: 'Missing key exchange trading pairs (Upbit, Bithumb, etc).',
        published_at: '2022-02-16T19:21:34.000Z',
        created_at: '2022-02-16T19:21:33.000Z',
        updated_at: '2022-10-21T11:10:43.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 20,
                name: 'coincap-io.png',
                alternativeText: 'CoinCap',
                caption: '',
                width: 500,
                height: 219,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coincap-io.png',
                        hash: 'thumbnail_coincap_io_5bbe710c86',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 107,
                        size: 7.07,
                        path: null,
                        url: '/uploads/thumbnail_coincap_io_5bbe710c86.png',
                    },
                },
                hash: 'coincap_io_5bbe710c86',
                ext: '.png',
                mime: 'image/png',
                size: 4.4,
                url: '/uploads/coincap_io_5bbe710c86.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:10:42.000Z',
            },
        ],
    },
    {
        id: 10,
        name: 'Matrixport',
        url: 'https://www.matrixport.com/en',
        ecash_brand: true,
        ecash_address_format: false,
        decimal_place: 2,
        issues: 'No proper eCash services (only supporting deposit and withdrawal) and a high withdrawal fee of 10,000 bits (XEC).',
        published_at: '2022-02-16T19:26:32.000Z',
        created_at: '2022-02-16T19:26:30.000Z',
        updated_at: '2022-02-18T21:39:29.000Z',
        fiat_deposit_options: null,
        logo: [
            {
                id: 44,
                name: 'matrixport.png',
                alternativeText: '',
                caption: '',
                width: 400,
                height: 83,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_matrixport.png',
                        hash: 'thumbnail_matrixport_b76e44ecb7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 51,
                        size: 5.57,
                        path: null,
                        url: '/uploads/thumbnail_matrixport_b76e44ecb7.png',
                    },
                },
                hash: 'matrixport_b76e44ecb7',
                ext: '.png',
                mime: 'image/png',
                size: 5.33,
                url: '/uploads/matrixport_b76e44ecb7.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-02-10T21:24:52.000Z',
            },
        ],
    },
    {
        id: 13,
        name: 'Cashtab',
        url: 'https://cashtab.com/#/wallet',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-09-26T00:08:06.000Z',
        created_at: '2022-09-26T00:01:31.000Z',
        updated_at: '2022-10-21T11:10:14.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 79,
                name: 'cashtab_xec.png',
                alternativeText: 'Cashtab',
                caption: '',
                width: 710,
                height: 125,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_cashtab_xec.png',
                        hash: 'thumbnail_cashtab_xec_37da0eae8e',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 43,
                        size: 7.31,
                        path: null,
                        url: '/uploads/thumbnail_cashtab_xec_37da0eae8e.png',
                    },
                    small: {
                        name: 'small_cashtab_xec.png',
                        hash: 'small_cashtab_xec_37da0eae8e',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 88,
                        size: 17.29,
                        path: null,
                        url: '/uploads/small_cashtab_xec_37da0eae8e.png',
                    },
                },
                hash: 'cashtab_xec_37da0eae8e',
                ext: '.png',
                mime: 'image/png',
                size: 6.29,
                url: '/uploads/cashtab_xec_37da0eae8e.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-09-26T00:04:55.000Z',
                updated_at: '2022-10-21T11:10:12.000Z',
            },
        ],
    },
    {
        id: 14,
        name: 'SwapSpace',
        url: 'https://swapspace.co/?to=xec&amount=1',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 5,
        issues: null,
        published_at: '2022-11-16T05:23:35.000Z',
        created_at: '2022-11-16T05:21:55.000Z',
        updated_at: '2022-11-16T05:23:35.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 87,
                name: 'SwapSpaceLogoBlackStacked.svg',
                alternativeText: '',
                caption: '',
                width: 710,
                height: 246,
                formats: null,
                hash: 'Swap_Space_Logo_Black_Stacked_98c54408f7',
                ext: '.svg',
                mime: 'image/svg+xml',
                size: 3.86,
                url: '/uploads/Swap_Space_Logo_Black_Stacked_98c54408f7.svg',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-11-16T05:21:49.000Z',
                updated_at: '2022-11-16T05:21:49.000Z',
            },
        ],
    },
    {
        id: 15,
        name: 'Swapzone',
        url: 'https://swapzone.io/exchange/eth/xec',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 8,
        issues: null,
        published_at: '2022-11-16T05:29:20.000Z',
        created_at: '2022-11-16T05:27:04.000Z',
        updated_at: '2022-11-16T05:29:20.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 88,
                name: 'Swapzone logo (1).svg',
                alternativeText: '',
                caption: '',
                width: 240,
                height: 88,
                formats: null,
                hash: 'Swapzone_logo_1_25d2ec1093',
                ext: '.svg',
                mime: 'image/svg+xml',
                size: 4.59,
                url: '/uploads/Swapzone_logo_1_25d2ec1093.svg',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-11-16T05:27:00.000Z',
                updated_at: '2022-11-16T05:27:00.000Z',
            },
        ],
    },
    {
        id: 17,
        name: 'PayButton',
        url: 'https://paybutton.org/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T01:32:32.000Z',
        created_at: '2023-02-17T01:31:38.000Z',
        updated_at: '2023-02-17T01:32:32.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 101,
                name: 'pbLogoNoBorder_white.png',
                alternativeText: '',
                caption: '',
                width: 600,
                height: 112,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_pbLogoNoBorder_white.png',
                        hash: 'thumbnail_pb_Logo_No_Border_white_4821b0d3fd',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 46,
                        size: 5.6,
                        path: null,
                        url: '/uploads/thumbnail_pb_Logo_No_Border_white_4821b0d3fd.png',
                    },
                    small: {
                        name: 'small_pbLogoNoBorder_white.png',
                        hash: 'small_pb_Logo_No_Border_white_4821b0d3fd',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 93,
                        size: 12.41,
                        path: null,
                        url: '/uploads/small_pb_Logo_No_Border_white_4821b0d3fd.png',
                    },
                },
                hash: 'pb_Logo_No_Border_white_4821b0d3fd',
                ext: '.png',
                mime: 'image/png',
                size: 3.68,
                url: '/uploads/pb_Logo_No_Border_white_4821b0d3fd.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T01:31:30.000Z',
                updated_at: '2023-02-17T01:31:30.000Z',
            },
        ],
    },
    {
        id: 18,
        name: 'Gorbeious',
        url: 'https://gorbeious.cash/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T08:54:11.000Z',
        created_at: '2023-02-17T08:52:27.000Z',
        updated_at: '2023-02-17T17:03:46.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 112,
                name: 'gorbeious.png',
                alternativeText: '',
                caption: '',
                width: 600,
                height: 132,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_gorbeious.png',
                        hash: 'thumbnail_gorbeious_fbc936deba',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 54,
                        size: 6.49,
                        path: null,
                        url: '/uploads/thumbnail_gorbeious_fbc936deba.png',
                    },
                    small: {
                        name: 'small_gorbeious.png',
                        hash: 'small_gorbeious_fbc936deba',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 110,
                        size: 17.2,
                        path: null,
                        url: '/uploads/small_gorbeious_fbc936deba.png',
                    },
                },
                hash: 'gorbeious_fbc936deba',
                ext: '.png',
                mime: 'image/png',
                size: 4.74,
                url: '/uploads/gorbeious_fbc936deba.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T17:03:37.000Z',
                updated_at: '2023-02-17T17:03:37.000Z',
            },
        ],
    },
    {
        id: 19,
        name: 'Cert.cash',
        url: 'https://cert.cash/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T09:13:18.000Z',
        created_at: '2023-02-17T09:13:15.000Z',
        updated_at: '2023-02-17T09:15:44.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 107,
                name: 'cert logo.png',
                alternativeText: '',
                caption: '',
                width: 513,
                height: 118,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_cert logo.png',
                        hash: 'thumbnail_cert_logo_949834d8bb',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 56,
                        size: 7.02,
                        path: null,
                        url: '/uploads/thumbnail_cert_logo_949834d8bb.png',
                    },
                    small: {
                        name: 'small_cert logo.png',
                        hash: 'small_cert_logo_949834d8bb',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 115,
                        size: 15.07,
                        path: null,
                        url: '/uploads/small_cert_logo_949834d8bb.png',
                    },
                },
                hash: 'cert_logo_949834d8bb',
                ext: '.png',
                mime: 'image/png',
                size: 5.4,
                url: '/uploads/cert_logo_949834d8bb.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T09:15:39.000Z',
                updated_at: '2023-02-17T09:15:39.000Z',
            },
        ],
    },
    {
        id: 20,
        name: 'Badger Universal Token',
        url: 'https://bux.digital/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T17:02:40.000Z',
        created_at: '2023-02-17T16:45:26.000Z',
        updated_at: '2023-02-17T17:09:44.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 110,
                name: 'BUX.Digital',
                alternativeText: 'Badger Universal Token',
                caption: '',
                width: 302,
                height: 48,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_BUX.Digital',
                        hash: 'thumbnail_bux_digital_7cb745f6ad',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 39,
                        size: 5.14,
                        path: null,
                        url: '/uploads/thumbnail_bux_digital_7cb745f6ad.png',
                    },
                },
                hash: 'bux_digital_7cb745f6ad',
                ext: '.png',
                mime: 'image/png',
                size: 2.63,
                url: '/uploads/bux_digital_7cb745f6ad.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T16:53:31.000Z',
                updated_at: '2023-02-24T11:10:40.000Z',
            },
        ],
    },
    {
        id: 23,
        name: 'Flashift',
        url: 'https://exchange.flashift.app/?currency_from=btc&currency_to=xec&amount=0.1',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 8,
        issues: null,
        published_at: '2023-05-03T12:40:30.000Z',
        created_at: '2023-05-03T12:39:35.000Z',
        updated_at: '2023-05-03T12:47:15.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 116,
                name: 'Flashift_-BigLogo.png',
                alternativeText: '',
                caption: '',
                width: 620,
                height: 310,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_Flashift_-BigLogo.png',
                        hash: 'thumbnail_Flashift_Big_Logo_d41607b8ce',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 123,
                        size: 8.88,
                        path: null,
                        url: '/uploads/thumbnail_Flashift_Big_Logo_d41607b8ce.png',
                    },
                    small: {
                        name: 'small_Flashift_-BigLogo.png',
                        hash: 'small_Flashift_Big_Logo_d41607b8ce',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 250,
                        size: 20.18,
                        path: null,
                        url: '/uploads/small_Flashift_Big_Logo_d41607b8ce.png',
                    },
                },
                hash: 'Flashift_Big_Logo_d41607b8ce',
                ext: '.png',
                mime: 'image/png',
                size: 17.31,
                url: '/uploads/Flashift_Big_Logo_d41607b8ce.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-05-03T12:42:17.000Z',
                updated_at: '2023-05-03T12:42:17.000Z',
            },
        ],
    },
];

export const scoredMockExchanges = [
    {
        id: 1,
        name: 'Binance',
        published_at: '2022-02-03T22:59:16.000Z',
        created_at: '2022-02-03T22:59:13.000Z',
        updated_at: '2022-11-18T20:36:19.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.binance.com/en/trade/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT', 'BUSD'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: true,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['EUR', 'GBP', 'NZD', 'RUB', 'TRY', 'UAH', 'USD'],
        logo: {
            id: 1,
            name: 'binance.png',
            alternativeText: 'Binance',
            caption: '',
            width: 249,
            height: 50,
            formats: {
                thumbnail: {
                    name: 'thumbnail_binance.png',
                    hash: 'thumbnail_binance_64d10b4b7d',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 49,
                    size: 6.31,
                    path: null,
                    url: '/uploads/thumbnail_binance_64d10b4b7d.png',
                },
            },
            hash: 'binance_64d10b4b7d',
            ext: '.png',
            mime: 'image/png',
            size: 3.39,
            url: '/uploads/binance_64d10b4b7d.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:07:22.000Z',
            updated_at: '2022-11-18T20:36:08.000Z',
        },
        score: 90,
    },
    {
        id: 4,
        name: 'Bithumb',
        published_at: '2022-02-10T21:27:11.000Z',
        created_at: '2022-02-10T21:27:09.000Z',
        updated_at: '2022-10-21T08:16:34.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://en.bithumb.com/trade/order/XEC_KRW',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 30,
        trading_pairs: ['KRW'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: true,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 14,
            name: 'bithumb.png',
            alternativeText: 'Bithumb',
            caption: '',
            width: 634,
            height: 192,
            formats: {
                thumbnail: {
                    name: 'thumbnail_bithumb.png',
                    hash: 'thumbnail_bithumb_e7d49b0753',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 74,
                    size: 7.08,
                    path: null,
                    url: '/uploads/thumbnail_bithumb_e7d49b0753.png',
                },
                small: {
                    name: 'small_bithumb.png',
                    hash: 'small_bithumb_e7d49b0753',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 151,
                    size: 15.98,
                    path: null,
                    url: '/uploads/small_bithumb_e7d49b0753.png',
                },
            },
            hash: 'bithumb_e7d49b0753',
            ext: '.png',
            mime: 'image/png',
            size: 1.81,
            url: '/uploads/bithumb_e7d49b0753.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2022-10-21T08:16:31.000Z',
        },
        score: 65,
    },
    {
        id: 5,
        name: 'CoinEx',
        published_at: '2022-02-10T23:16:37.000Z',
        created_at: '2022-02-10T23:16:34.000Z',
        updated_at: '2023-06-12T04:29:59.000Z',
        ecash_brand: true,
        decimal_places: 8,
        ecash_deposit_address_format: true,
        url: 'https://www.coinex.com/info/XEC',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT', 'USDC'],
        withdrawal_fee: 5,
        xec_withdrawal_fee: true,
        quirks_issues:
            "XEC/BTC pair needs to be added. They said they would figure out something for that but haven't given us an ETA. Also, they're requiring 120 confirmations to withdraw (and 20 to deposit) which seems like a lot.",
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 71,
            name: 'coinex.png',
            alternativeText: 'CoinEx',
            caption: '',
            width: 538,
            height: 173,
            formats: {
                thumbnail: {
                    name: 'thumbnail_coinex.png',
                    hash: 'thumbnail_coinex_7167e1c81d',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 79,
                    size: 8.13,
                    path: null,
                    url: '/uploads/thumbnail_coinex_7167e1c81d.png',
                },
                small: {
                    name: 'small_coinex.png',
                    hash: 'small_coinex_7167e1c81d',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 161,
                    size: 21.12,
                    path: null,
                    url: '/uploads/small_coinex_7167e1c81d.png',
                },
            },
            hash: 'coinex_7167e1c81d',
            ext: '.png',
            mime: 'image/png',
            size: 3.05,
            url: '/uploads/coinex_7167e1c81d.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-07-27T13:21:36.000Z',
            updated_at: '2022-10-21T08:22:59.000Z',
        },
        score: 95,
    },
    {
        id: 8,
        name: 'Indodax',
        published_at: '2022-02-10T23:37:32.000Z',
        created_at: '2022-02-10T23:37:30.000Z',
        updated_at: '2022-11-15T13:28:40.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://indodax.com/market/XECUSDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['IDR'],
        logo: {
            id: 38,
            name: 'indodax.png',
            alternativeText: 'Indodax',
            caption: '',
            width: 500,
            height: 102,
            formats: {
                thumbnail: {
                    name: 'thumbnail_indodax.png',
                    hash: 'thumbnail_indodax_d61d9ee106',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 50,
                    size: 8.67,
                    path: null,
                    url: '/uploads/thumbnail_indodax_d61d9ee106.png',
                },
            },
            hash: 'indodax_d61d9ee106',
            ext: '.png',
            mime: 'image/png',
            size: 7.22,
            url: '/uploads/indodax_d61d9ee106.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:28:39.000Z',
        },
        score: 80,
    },
    {
        id: 13,
        name: 'Hotbit',
        published_at: '2022-10-01T04:45:37.000Z',
        created_at: '2022-02-15T22:13:04.000Z',
        updated_at: '2022-12-09T11:42:34.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.hotbit.io/exchange?symbol=XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 2,
        trading_pairs: ['USDT'],
        withdrawal_fee: 5000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 35,
            name: 'hotbit.png',
            alternativeText: 'Hotbit',
            caption: '',
            width: 500,
            height: 138,
            formats: {
                thumbnail: {
                    name: 'thumbnail_hotbit.png',
                    hash: 'thumbnail_hotbit_3edd0cc911',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 68,
                    size: 6.19,
                    path: null,
                    url: '/uploads/thumbnail_hotbit_3edd0cc911.png',
                },
            },
            hash: 'hotbit_3edd0cc911',
            ext: '.png',
            mime: 'image/png',
            size: 4.56,
            url: '/uploads/hotbit_3edd0cc911.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:51.000Z',
            updated_at: '2022-10-21T08:27:19.000Z',
        },
        score: 60,
    },
    {
        id: 14,
        name: 'Korbit',
        published_at: '2022-02-15T22:14:34.000Z',
        created_at: '2022-02-15T22:14:33.000Z',
        updated_at: '2022-10-21T08:29:22.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://exchange.korbit.co.kr/markets/?market=xec-krw',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 12,
        trading_pairs: ['KRW'],
        withdrawal_fee: 10000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 40,
            name: 'korbit.png',
            alternativeText: 'Korbit',
            caption: '',
            width: 500,
            height: 156,
            formats: {
                thumbnail: {
                    name: 'thumbnail_korbit.png',
                    hash: 'thumbnail_korbit_c7f68f9a00',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 76,
                    size: 6.34,
                    path: null,
                    url: '/uploads/thumbnail_korbit_c7f68f9a00.png',
                },
            },
            hash: 'korbit_c7f68f9a00',
            ext: '.png',
            mime: 'image/png',
            size: 3.5,
            url: '/uploads/korbit_c7f68f9a00.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:29:19.000Z',
        },
        score: 65,
    },
    {
        id: 15,
        name: 'Bitfinex',
        published_at: '2022-02-15T22:16:26.000Z',
        created_at: '2022-02-15T22:16:25.000Z',
        updated_at: '2023-06-09T15:45:12.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://trading.bitfinex.com/t/XEC:USD',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USD'],
        withdrawal_fee: 0,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['USD', 'EUR', 'GBP', 'JPY', 'CNH'],
        logo: {
            id: 10,
            name: 'bitfinex.png',
            alternativeText: 'Bitfinex',
            caption: '',
            width: 422,
            height: 50,
            formats: {
                thumbnail: {
                    name: 'thumbnail_bitfinex.png',
                    hash: 'thumbnail_bitfinex_63accf2654',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 29,
                    size: 4.27,
                    path: null,
                    url: '/uploads/thumbnail_bitfinex_63accf2654.png',
                },
            },
            hash: 'bitfinex_63accf2654',
            ext: '.png',
            mime: 'image/png',
            size: 3.98,
            url: '/uploads/bitfinex_63accf2654.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2022-11-18T21:31:41.000Z',
        },
        score: 85,
    },
    {
        id: 16,
        name: 'KUCOIN',
        published_at: '2022-02-15T22:18:15.000Z',
        created_at: '2022-02-15T22:18:13.000Z',
        updated_at: '2022-10-21T08:29:51.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://trade.kucoin.com/trade/XEC-USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 6,
        trading_pairs: ['USDT'],
        withdrawal_fee: 5000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 50,
            name: 'kucoin.png',
            alternativeText: 'KuCoin',
            caption: '',
            width: 600,
            height: 150,
            formats: {
                thumbnail: {
                    name: 'thumbnail_kucoin.png',
                    hash: 'thumbnail_kucoin_cbf360cb43',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 61,
                    size: 6.4,
                    path: null,
                    url: '/uploads/thumbnail_kucoin_cbf360cb43.png',
                },
                small: {
                    name: 'small_kucoin.png',
                    hash: 'small_kucoin_cbf360cb43',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 125,
                    size: 15.18,
                    path: null,
                    url: '/uploads/small_kucoin_cbf360cb43.png',
                },
            },
            hash: 'kucoin_cbf360cb43',
            ext: '.png',
            mime: 'image/png',
            size: 2.67,
            url: '/uploads/kucoin_cbf360cb43.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:29:48.000Z',
        },
        score: 60,
    },
    {
        id: 17,
        name: 'UPbit',
        published_at: '2022-02-15T22:19:41.000Z',
        created_at: '2022-02-15T22:19:40.000Z',
        updated_at: '2022-10-21T08:33:29.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://upbit.com/exchange?code=CRIX.UPBIT.KRW-XEC',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 30,
        trading_pairs: ['KRW'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 57,
            name: 'upbit.png',
            alternativeText: 'UPBit',
            caption: '',
            width: 490,
            height: 154,
            formats: {
                thumbnail: {
                    name: 'thumbnail_upbit.png',
                    hash: 'thumbnail_upbit_098ce8e0b6',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 77,
                    size: 5.05,
                    path: null,
                    url: '/uploads/thumbnail_upbit_098ce8e0b6.png',
                },
            },
            hash: 'upbit_098ce8e0b6',
            ext: '.png',
            mime: 'image/png',
            size: 0.82,
            url: '/uploads/upbit_098ce8e0b6.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:33:27.000Z',
        },
        score: 65,
    },
    {
        id: 18,
        name: 'LBank',
        published_at: '2022-02-15T22:21:38.000Z',
        created_at: '2022-02-15T22:21:37.000Z',
        updated_at: '2023-01-31T18:54:03.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.lbank.info/exchange/xec/usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1500,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 99,
            name: '189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
            alternativeText: '',
            caption: '',
            width: 2480,
            height: 704,
            formats: {
                thumbnail: {
                    name: 'thumbnail_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'thumbnail_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 70,
                    size: 5.36,
                    path: null,
                    url: '/uploads/thumbnail_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
                large: {
                    name: 'large_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'large_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 1000,
                    height: 284,
                    size: 23.64,
                    path: null,
                    url: '/uploads/large_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
                medium: {
                    name: 'medium_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'medium_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 213,
                    size: 17.08,
                    path: null,
                    url: '/uploads/medium_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
                small: {
                    name: 'small_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'small_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 142,
                    size: 11.01,
                    path: null,
                    url: '/uploads/small_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
            },
            hash: '189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
            ext: '.png',
            mime: 'image/png',
            size: 5.68,
            url: '/uploads/189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2023-01-31T06:55:12.000Z',
            updated_at: '2023-01-31T06:55:12.000Z',
        },
        score: 75,
    },
    {
        id: 19,
        name: 'Poloniex',
        published_at: '2022-02-15T22:22:47.000Z',
        created_at: '2022-02-15T22:22:45.000Z',
        updated_at: '2022-10-21T08:32:37.000Z',
        ecash_brand: true,
        decimal_places: 8,
        ecash_deposit_address_format: true,
        url: 'https://poloniex.com/spot/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 10,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'Supports 40+ fiat currencies through Simplex payment partner',
        ],
        logo: {
            id: 76,
            name: 'poloniex_logo-freelogovectors.net_.png',
            alternativeText: 'Poloniex',
            caption: '',
            width: 1423,
            height: 365,
            formats: {
                thumbnail: {
                    name: 'thumbnail_poloniex_logo-freelogovectors.net_.png',
                    hash: 'thumbnail_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 63,
                    size: 6.65,
                    path: null,
                    url: '/uploads/thumbnail_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
                large: {
                    name: 'large_poloniex_logo-freelogovectors.net_.png',
                    hash: 'large_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 1000,
                    height: 257,
                    size: 29.92,
                    path: null,
                    url: '/uploads/large_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
                medium: {
                    name: 'medium_poloniex_logo-freelogovectors.net_.png',
                    hash: 'medium_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 192,
                    size: 21.87,
                    path: null,
                    url: '/uploads/medium_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
                small: {
                    name: 'small_poloniex_logo-freelogovectors.net_.png',
                    hash: 'small_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 128,
                    size: 14.21,
                    path: null,
                    url: '/uploads/small_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
            },
            hash: 'poloniex_logo_freelogovectors_net_f835d8039a',
            ext: '.png',
            mime: 'image/png',
            size: 4.76,
            url: '/uploads/poloniex_logo_freelogovectors_net_f835d8039a.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-08-18T06:25:06.000Z',
            updated_at: '2022-10-21T08:32:32.000Z',
        },
        score: 65,
    },
    {
        id: 20,
        name: 'Huobi',
        published_at: '2023-01-10T21:27:20.000Z',
        created_at: '2022-02-15T22:33:53.000Z',
        updated_at: '2023-01-10T21:27:20.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://www.huobi.com/en-in/exchange/xec_usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: "Don't want to use the new address format",
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['60+ Currencies through Visa/Mastercard'],
        logo: {
            id: 37,
            name: 'huobi.png',
            alternativeText: 'Huobi',
            caption: '',
            width: 500,
            height: 152,
            formats: {
                thumbnail: {
                    name: 'thumbnail_huobi.png',
                    hash: 'thumbnail_huobi_cfbdcdb9d7',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 74,
                    size: 6.73,
                    path: null,
                    url: '/uploads/thumbnail_huobi_cfbdcdb9d7.png',
                },
            },
            hash: 'huobi_cfbdcdb9d7',
            ext: '.png',
            mime: 'image/png',
            size: 4.66,
            url: '/uploads/huobi_cfbdcdb9d7.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:28:20.000Z',
        },
        score: 85,
    },
    {
        id: 21,
        name: 'MEXC',
        published_at: '2022-02-15T22:38:47.000Z',
        created_at: '2022-02-15T22:38:45.000Z',
        updated_at: '2023-02-16T08:53:26.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://www.mexc.com/exchange/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 2,
        trading_pairs: ['USDT'],
        withdrawal_fee: 2000,
        xec_withdrawal_fee: null,
        quirks_issues: 'Using legacy (BTC) address format for deposits',
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'AED',
            'AUD',
            'BDT',
            'BRL',
            'CAD',
            'EGP',
            'EUR',
            'GBP',
            'GHS',
            'IDR',
            'INR',
            'JPY',
            'KRW',
            'KZT',
            'MYR',
            'MMK',
            'TWD',
            'NGN',
            'PHP',
            'PKR',
            'RUB',
            'TZS',
            'THB',
            'TRY',
            'UAH',
            'USD',
            'VES',
            'VND',
        ],
        logo: {
            id: 55,
            name: 'mexc.png',
            alternativeText: 'MEXC',
            caption: '',
            width: 1586,
            height: 356,
            formats: {
                thumbnail: {
                    name: 'thumbnail_mexc.png',
                    hash: 'thumbnail_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 55,
                    size: 7.82,
                    path: null,
                    url: '/uploads/thumbnail_mexc_f3083ac0c3.png',
                },
                large: {
                    name: 'large_mexc.png',
                    hash: 'large_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 1000,
                    height: 224,
                    size: 42.92,
                    path: null,
                    url: '/uploads/large_mexc_f3083ac0c3.png',
                },
                medium: {
                    name: 'medium_mexc.png',
                    hash: 'medium_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 168,
                    size: 32.96,
                    path: null,
                    url: '/uploads/medium_mexc_f3083ac0c3.png',
                },
                small: {
                    name: 'small_mexc.png',
                    hash: 'small_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 112,
                    size: 19.21,
                    path: null,
                    url: '/uploads/small_mexc_f3083ac0c3.png',
                },
            },
            hash: 'mexc_f3083ac0c3',
            ext: '.png',
            mime: 'image/png',
            size: 6.34,
            url: '/uploads/mexc_f3083ac0c3.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:31:31.000Z',
        },
        score: 65,
    },
    {
        id: 23,
        name: 'Ascendex',
        published_at: '2022-02-15T23:26:01.000Z',
        created_at: '2022-02-15T23:25:59.000Z',
        updated_at: '2022-10-21T08:13:43.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: false,
        url: 'https://ascendex.com/en/cashtrade-spottrading/usdt/xec',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 15,
        trading_pairs: ['USDT'],
        withdrawal_fee: 10000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'AED',
            'ARS',
            'AUD',
            'AZN',
            'BGN',
            'BRL',
            'CAD',
            'CHF',
            'CLP',
            'COP',
            'CRC',
            'CZK',
            'DKK',
            'DOP',
            'EGP',
            'EUR',
            'GBP',
            'GEL',
            'GHS',
            'HKD',
            'HRK',
            'HUF',
            'IDR',
            'ILS',
            'INR',
            'JOD',
            'JPY',
            'KES',
            'KRW',
            'KWD',
            'KZT',
            'LKR',
            'MDL',
            'MXN',
            'MYR',
            'NAD',
            'NGN',
            'NOK',
            'NZD',
            'OMR',
            'PEN',
            'PHP',
            'PKR',
            'PLN',
            'QAR',
            'RON',
            'RUB',
            'SAR',
            'SEK',
            'SGD',
            'THB',
            'TRY',
            'TWD',
            'TZS',
            'UAH',
            'UGX',
            'USD',
            'UYU',
            'UZS',
            'VND',
            'ZAR',
        ],
        logo: {
            id: 5,
            name: 'ascendex.png',
            alternativeText: '',
            caption: '',
            width: 500,
            height: 100,
            formats: {
                thumbnail: {
                    name: 'thumbnail_ascendex.png',
                    hash: 'thumbnail_ascendex_68ea0e377c',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 49,
                    size: 5.81,
                    path: null,
                    url: '/uploads/thumbnail_ascendex_68ea0e377c.png',
                },
            },
            hash: 'ascendex_68ea0e377c',
            ext: '.png',
            mime: 'image/png',
            size: 4.92,
            url: '/uploads/ascendex_68ea0e377c.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:49.000Z',
            updated_at: '2022-10-21T08:15:24.000Z',
        },
        score: 40,
    },
    {
        id: 24,
        name: 'Coinone',
        published_at: '2022-02-15T23:27:21.000Z',
        created_at: '2022-02-15T23:27:20.000Z',
        updated_at: '2022-10-21T08:23:22.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://coinone.co.kr/exchange/trade/xec/krw',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 10,
        trading_pairs: ['KRW'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 26,
            name: 'coinone.png',
            alternativeText: 'Coinone',
            caption: '',
            width: 664,
            height: 130,
            formats: {
                thumbnail: {
                    name: 'thumbnail_coinone.png',
                    hash: 'thumbnail_coinone_d6e3fa4fd3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 48,
                    size: 6.08,
                    path: null,
                    url: '/uploads/thumbnail_coinone_d6e3fa4fd3.png',
                },
                small: {
                    name: 'small_coinone.png',
                    hash: 'small_coinone_d6e3fa4fd3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 98,
                    size: 14.44,
                    path: null,
                    url: '/uploads/small_coinone_d6e3fa4fd3.png',
                },
            },
            hash: 'coinone_d6e3fa4fd3',
            ext: '.png',
            mime: 'image/png',
            size: 3.55,
            url: '/uploads/coinone_d6e3fa4fd3.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:51.000Z',
            updated_at: '2022-10-21T08:23:19.000Z',
        },
        score: 65,
    },
    {
        id: 25,
        name: 'gate.io',
        published_at: '2022-02-15T23:28:48.000Z',
        created_at: '2022-02-15T23:28:47.000Z',
        updated_at: '2023-04-22T01:30:59.000Z',
        ecash_brand: true,
        decimal_places: 3,
        ecash_deposit_address_format: true,
        url: 'https://www.gate.io/tw/trade/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 6,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['CNY', 'KRW', 'VND', 'USD', 'INR', 'TRY'],
        logo: {
            id: 73,
            name: 'gate-io.png',
            alternativeText: '',
            caption: '',
            width: 400,
            height: 100,
            formats: {
                thumbnail: {
                    name: 'thumbnail_gate-io.png',
                    hash: 'thumbnail_gate_io_793eef8007',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 61,
                    size: 7.01,
                    path: null,
                    url: '/uploads/thumbnail_gate_io_793eef8007.png',
                },
            },
            hash: 'gate_io_793eef8007',
            ext: '.png',
            mime: 'image/png',
            size: 3.07,
            url: '/uploads/gate_io_793eef8007.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-07-27T13:28:57.000Z',
            updated_at: '2022-10-21T08:26:54.000Z',
        },
        score: 85,
    },
    {
        id: 27,
        name: 'OKX',
        published_at: '2022-02-15T23:31:12.000Z',
        created_at: '2022-02-15T23:31:11.000Z',
        updated_at: '2023-04-17T05:40:00.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.okex.com/markets/prices/ecash-xec',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 30,
        trading_pairs: ['USDT'],
        withdrawal_fee: 800,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'Supports 90+ fiat currencies via credit card/debit card/wire transfer/paypal and more.',
        ],
        logo: {
            id: 43,
            name: 'okx.png',
            alternativeText: 'OKX',
            caption: '',
            width: 164,
            height: 72,
            formats: {},
            hash: 'okx_59b3b0c033',
            ext: '.png',
            mime: 'image/png',
            size: 0.22,
            url: '/uploads/okx_59b3b0c033.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:31:45.000Z',
        },
        score: 65,
    },
    {
        id: 30,
        name: 'BKEX',
        published_at: '2022-02-15T23:36:07.000Z',
        created_at: '2022-02-15T23:36:05.000Z',
        updated_at: '2022-11-18T21:32:10.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.bkex.com/trade/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 60,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['THB'],
        logo: {
            id: 15,
            name: 'bkex.png',
            alternativeText: 'Bkex',
            caption: '',
            width: 168,
            height: 48,
            formats: {},
            hash: 'bkex_1f3d977204',
            ext: '.png',
            mime: 'image/png',
            size: 1.32,
            url: '/uploads/bkex_1f3d977204.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2023-02-17T07:35:36.000Z',
        },
        score: 65,
    },
    {
        id: 33,
        name: 'SouthXchange',
        published_at: '2022-02-15T23:45:53.000Z',
        created_at: '2022-02-15T23:45:52.000Z',
        updated_at: '2022-12-21T05:54:25.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://main.southxchange.com/Market/Book/XEC/BTC',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['BTC'],
        withdrawal_fee: 3,
        xec_withdrawal_fee: null,
        quirks_issues:
            'We will enable deposits and withdrawals when we have a free server available to run the wallet. If you are able to sponsor a server then we can enable it asap. Otherwise it might take some time.',
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 48,
            name: 'southxchange.png',
            alternativeText: 'southXchange',
            caption: '',
            width: 334,
            height: 80,
            formats: {
                thumbnail: {
                    name: 'thumbnail_southxchange.png',
                    hash: 'thumbnail_southxchange_503b223a1e',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 59,
                    size: 6.08,
                    path: null,
                    url: '/uploads/thumbnail_southxchange_503b223a1e.png',
                },
            },
            hash: 'southxchange_503b223a1e',
            ext: '.png',
            mime: 'image/png',
            size: 2.17,
            url: '/uploads/southxchange_503b223a1e.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:32:52.000Z',
        },
        score: 90,
    },
    {
        id: 34,
        name: 'Bybit',
        published_at: '2022-02-15T23:47:02.000Z',
        created_at: '2022-02-15T23:47:00.000Z',
        updated_at: '2022-10-21T08:22:39.000Z',
        ecash_brand: true,
        decimal_places: 1,
        ecash_deposit_address_format: false,
        url: 'https://www.bybit.com/trade/spot/XEC/USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 60,
        trading_pairs: ['USDT'],
        withdrawal_fee: 10000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 18,
            name: 'bybit.png',
            alternativeText: 'Bybit',
            caption: '',
            width: 767,
            height: 266,
            formats: {
                thumbnail: {
                    name: 'thumbnail_bybit.png',
                    hash: 'thumbnail_bybit_303e7734d1',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 85,
                    size: 4.97,
                    path: null,
                    url: '/uploads/thumbnail_bybit_303e7734d1.png',
                },
                medium: {
                    name: 'medium_bybit.png',
                    hash: 'medium_bybit_303e7734d1',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 260,
                    size: 16.96,
                    path: null,
                    url: '/uploads/medium_bybit_303e7734d1.png',
                },
                small: {
                    name: 'small_bybit.png',
                    hash: 'small_bybit_303e7734d1',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 173,
                    size: 10.32,
                    path: null,
                    url: '/uploads/small_bybit_303e7734d1.png',
                },
            },
            hash: 'bybit_303e7734d1',
            ext: '.png',
            mime: 'image/png',
            size: 3.66,
            url: '/uploads/bybit_303e7734d1.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2022-10-21T08:22:33.000Z',
        },
        score: 40,
    },
    {
        id: 35,
        name: 'HitBTC',
        published_at: '2022-11-11T06:40:56.000Z',
        created_at: '2022-02-15T23:48:16.000Z',
        updated_at: '2022-11-21T23:29:30.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: false,
        url: 'https://hitbtc.com/xec-to-usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 10,
        trading_pairs: ['BTC', 'USDT'],
        withdrawal_fee: 150000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 31,
            name: 'hitbtc.png',
            alternativeText: '',
            caption: '',
            width: 400,
            height: 184,
            formats: {
                thumbnail: {
                    name: 'thumbnail_hitbtc.png',
                    hash: 'thumbnail_hitbtc_7016491270',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 113,
                    size: 9.34,
                    path: null,
                    url: '/uploads/thumbnail_hitbtc_7016491270.png',
                },
            },
            hash: 'hitbtc_7016491270',
            ext: '.png',
            mime: 'image/png',
            size: 10.19,
            url: '/uploads/hitbtc_7016491270.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:51.000Z',
            updated_at: '2022-02-10T21:24:51.000Z',
        },
        score: 50,
    },
    {
        id: 40,
        name: 'Hotcoin',
        published_at: '2022-09-17T01:55:47.000Z',
        created_at: '2022-06-23T05:44:32.000Z',
        updated_at: '2022-11-18T21:33:12.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.hotcoin.com/currencyExchange/xec_usdt',
        deposits_working: false,
        withdrawals_working: false,
        deposit_confirmations: 11,
        trading_pairs: ['USDT'],
        withdrawal_fee: null,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'CNY',
            'USD',
            'EUR',
            'GBP',
            'AED',
            'AMD',
            'ARS',
            'AUD',
            'BDT',
            'BHD',
            'BND',
            'BOB',
            'RSL',
            'CAD',
            'CLP',
            'COP',
            'DOP',
            'EGP',
            'GHS',
            'HKD',
            'IDR',
            'INR',
            'JPY',
            'KES',
            'KHR',
            'KWD',
            'KZT',
            'LAK',
            'LKR',
            'MAD',
            'MMK',
            'MNT',
            'MXN',
            'NGN',
            'NPR',
            'PAB',
            'PEN',
            'PHP',
            'PKR',
            'PLN',
            'PYG',
            'RON',
            'RUB',
            'VND',
            'THB',
            'TRY',
        ],
        logo: {
            id: 78,
            name: 'hotcoin logo-1.png',
            alternativeText: 'Hotcoin',
            caption: '',
            width: 334,
            height: 50,
            formats: {
                thumbnail: {
                    name: 'thumbnail_hotcoin logo-1.png',
                    hash: 'thumbnail_hotcoin_logo_1_7cd6c68edc',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 37,
                    size: 5.14,
                    path: null,
                    url: '/uploads/thumbnail_hotcoin_logo_1_7cd6c68edc.png',
                },
            },
            hash: 'hotcoin_logo_1_7cd6c68edc',
            ext: '.png',
            mime: 'image/png',
            size: 3.63,
            url: '/uploads/hotcoin_logo_1_7cd6c68edc.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-09-17T01:00:35.000Z',
            updated_at: '2022-11-18T21:33:09.000Z',
        },
        score: 30,
    },
    {
        id: 41,
        name: 'Bitrue',
        published_at: '2022-08-05T18:33:31.000Z',
        created_at: '2022-08-05T18:23:47.000Z',
        updated_at: '2022-12-08T06:43:36.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.bitrue.com/trade/xec_usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 82,
            name: 'Bitrue_44093e2318.png',
            alternativeText: '',
            caption: '',
            width: 597,
            height: 163,
            formats: {
                thumbnail: {
                    name: 'thumbnail_Bitrue_44093e2318.png',
                    hash: 'thumbnail_Bitrue_44093e2318_ef5bb48b0b',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 67,
                    size: 7.28,
                    path: null,
                    url: '/uploads/thumbnail_Bitrue_44093e2318_ef5bb48b0b.png',
                },
                small: {
                    name: 'small_Bitrue_44093e2318.png',
                    hash: 'small_Bitrue_44093e2318_ef5bb48b0b',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 137,
                    size: 17.07,
                    path: null,
                    url: '/uploads/small_Bitrue_44093e2318_ef5bb48b0b.png',
                },
            },
            hash: 'Bitrue_44093e2318_ef5bb48b0b',
            ext: '.png',
            mime: 'image/png',
            size: 4.98,
            url: '/uploads/Bitrue_44093e2318_ef5bb48b0b.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-10-21T08:17:27.000Z',
            updated_at: '2022-10-21T08:17:27.000Z',
        },
        score: 80,
    },
    {
        id: 43,
        name: 'FMFW.io',
        published_at: '2022-11-14T10:26:44.000Z',
        created_at: '2022-11-14T09:00:15.000Z',
        updated_at: '2022-12-16T13:14:19.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://fmfw.io/xec-to-usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 5,
        trading_pairs: ['USDT', 'BTC'],
        withdrawal_fee: 8660,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 86,
            name: 'IMG_20221114_175356_215.png',
            alternativeText: '',
            caption: '',
            width: 234,
            height: 50,
            formats: {},
            hash: 'IMG_20221114_175356_215_607f24f2e2',
            ext: '.png',
            mime: 'image/png',
            size: 2.86,
            url: '/uploads/IMG_20221114_175356_215_607f24f2e2.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-11-14T08:55:16.000Z',
            updated_at: '2022-11-18T21:19:47.000Z',
        },
        score: 75,
    },
    {
        id: 45,
        name: 'XT.com',
        published_at: '2022-11-30T20:14:13.000Z',
        created_at: '2022-11-29T06:28:27.000Z',
        updated_at: '2022-11-30T20:14:13.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: null,
        url: 'https://www.xt.com/tradePro/xec_usdt',
        deposits_working: false,
        withdrawals_working: false,
        deposit_confirmations: null,
        trading_pairs: ['USDT'],
        withdrawal_fee: null,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 92,
            name: 'xt_com_logo-freelogovectors.net_.png',
            alternativeText: '',
            caption: '',
            width: 320,
            height: 92,
            formats: {
                thumbnail: {
                    name: 'thumbnail_xt_com_logo-freelogovectors.net_.png',
                    hash: 'thumbnail_xt_com_logo_freelogovectors_net_274dddb9b6',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 70,
                    size: 7.3,
                    path: null,
                    url: '/uploads/thumbnail_xt_com_logo_freelogovectors_net_274dddb9b6.png',
                },
            },
            hash: 'xt_com_logo_freelogovectors_net_274dddb9b6',
            ext: '.png',
            mime: 'image/png',
            size: 7.65,
            url: '/uploads/xt_com_logo_freelogovectors_net_274dddb9b6.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-11-29T06:34:39.000Z',
            updated_at: '2022-11-29T06:34:39.000Z',
        },
        score: 25,
    },
    {
        id: 46,
        name: 'Bitbarg ',
        published_at: '2022-12-21T19:39:01.000Z',
        created_at: '2022-12-21T18:49:54.000Z',
        updated_at: '2022-12-22T03:05:47.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://bitbarg.com/',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 6,
        trading_pairs: ['IRR'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['IRR'],
        logo: {
            id: 95,
            name: 'Bitbarg.svg',
            alternativeText: '',
            caption: '',
            width: 209,
            height: 68,
            formats: null,
            hash: 'Bitbarg_0b2e57f56e',
            ext: '.svg',
            mime: 'image/svg+xml',
            size: 4.94,
            url: '/uploads/Bitbarg_0b2e57f56e.svg',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-12-21T19:41:05.000Z',
            updated_at: '2022-12-21T19:41:05.000Z',
        },
        score: 65,
    },
];

export const scoredMockInstantExchanges = [
    {
        id: 1,
        name: 'StealthEX',
        published_at: '2022-02-16T03:28:45.000Z',
        created_at: '2022-02-16T03:28:43.000Z',
        updated_at: '2022-10-21T11:13:10.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 8,
        ecash_deposit_address_format: true,
        url: 'https://stealthex.io/coin/xec',
        logo: [
            {
                id: 54,
                name: 'stealthex.png',
                alternativeText: 'StealthEX',
                caption: '',
                width: 793,
                height: 148,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_stealthex.png',
                        hash: 'thumbnail_stealthex_691f504038',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 46,
                        size: 6.33,
                        path: null,
                        url: '/uploads/thumbnail_stealthex_691f504038.png',
                    },
                    medium: {
                        name: 'medium_stealthex.png',
                        hash: 'medium_stealthex_691f504038',
                        ext: '.png',
                        mime: 'image/png',
                        width: 750,
                        height: 140,
                        size: 21.64,
                        path: null,
                        url: '/uploads/medium_stealthex_691f504038.png',
                    },
                    small: {
                        name: 'small_stealthex.png',
                        hash: 'small_stealthex_691f504038',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 93,
                        size: 13.83,
                        path: null,
                        url: '/uploads/small_stealthex_691f504038.png',
                    },
                },
                hash: 'stealthex_691f504038',
                ext: '.png',
                mime: 'image/png',
                size: 3.94,
                url: '/uploads/stealthex_691f504038.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-10-21T11:13:09.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 2,
        name: 'Godex',
        published_at: '2022-02-16T03:31:42.000Z',
        created_at: '2022-02-16T03:31:40.000Z',
        updated_at: '2022-10-21T11:12:31.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 8,
        ecash_deposit_address_format: true,
        url: 'https://godex.io/exchange?coin_from=USDT&coin_to=XEC&amount=500',
        logo: [
            {
                id: 27,
                name: 'godex.png',
                alternativeText: 'Godex',
                caption: '',
                width: 400,
                height: 106,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_godex.png',
                        hash: 'thumbnail_godex_c43971ace3',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 65,
                        size: 5.59,
                        path: null,
                        url: '/uploads/thumbnail_godex_c43971ace3.png',
                    },
                },
                hash: 'godex_c43971ace3',
                ext: '.png',
                mime: 'image/png',
                size: 2.27,
                url: '/uploads/godex_c43971ace3.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:12:30.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 3,
        name: 'SimpleSwap',
        published_at: '2022-02-16T03:32:23.000Z',
        created_at: '2022-02-16T03:32:18.000Z',
        updated_at: '2022-10-21T11:12:58.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 8,
        ecash_deposit_address_format: false,
        url: 'https://simpleswap.io/?to=xec',
        logo: [
            {
                id: 49,
                name: 'simpleswap.png',
                alternativeText: 'SimpleSwap',
                caption: '',
                width: 400,
                height: 77,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_simpleswap.png',
                        hash: 'thumbnail_simpleswap_5e3be28a36',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 47,
                        size: 6.38,
                        path: null,
                        url: '/uploads/thumbnail_simpleswap_5e3be28a36.png',
                    },
                },
                hash: 'simpleswap_5e3be28a36',
                ext: '.png',
                mime: 'image/png',
                size: 3.11,
                url: '/uploads/simpleswap_5e3be28a36.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-10-21T11:12:56.000Z',
            },
        ],
        score: 40,
    },
    {
        id: 4,
        name: 'Change Now',
        published_at: '2022-08-11T00:42:44.000Z',
        created_at: '2022-08-11T00:41:43.000Z',
        updated_at: '2022-10-21T11:12:13.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: null,
        decimal_place: null,
        ecash_deposit_address_format: true,
        url: 'https://changenow.io/?from=xec&to=usdttrc20',
        logo: [
            {
                id: 75,
                name: 'change-now.png',
                alternativeText: 'ChangeNOW',
                caption: '',
                width: 213,
                height: 150,
                formats: {},
                hash: 'change_now_fde3e4f2fa',
                ext: '.png',
                mime: 'image/png',
                size: 3.31,
                url: '/uploads/change_now_fde3e4f2fa.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-08-11T00:41:04.000Z',
                updated_at: '2022-10-21T11:12:11.000Z',
            },
        ],
        score: 90,
    },
    {
        id: 5,
        name: 'LetsExchange',
        published_at: '2022-09-16T20:27:49.000Z',
        created_at: '2022-09-16T20:27:38.000Z',
        updated_at: '2023-06-07T22:48:57.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: null,
        decimal_place: 8,
        ecash_deposit_address_format: true,
        url: 'https://letsexchange.io/',
        logo: [
            {
                id: 77,
                name: 'letsexchange.png',
                alternativeText: 'LetsExchange',
                caption: '',
                width: 380,
                height: 50,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_letsexchange.png',
                        hash: 'thumbnail_letsexchange_9a542bc886',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 32,
                        size: 5.52,
                        path: null,
                        url: '/uploads/thumbnail_letsexchange_9a542bc886.png',
                    },
                },
                hash: 'letsexchange_9a542bc886',
                ext: '.png',
                mime: 'image/png',
                size: 5.34,
                url: '/uploads/letsexchange_9a542bc886.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-09-16T20:25:25.000Z',
                updated_at: '2022-11-18T21:33:32.000Z',
            },
        ],
        score: 90,
    },
    {
        id: 6,
        name: 'EasyBit',
        published_at: '2022-10-21T22:56:40.000Z',
        created_at: '2022-10-21T22:50:10.000Z',
        updated_at: '2022-11-16T05:17:46.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 2,
        ecash_deposit_address_format: true,
        url: 'https://easybit.com/en/exchange#xec',
        logo: [
            {
                id: 85,
                name: 'EasyBit-logo.png',
                alternativeText: '',
                caption: '',
                width: 320,
                height: 86,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_EasyBit-logo.png',
                        hash: 'thumbnail_Easy_Bit_logo_342eaf5425',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 66,
                        size: 6.69,
                        path: null,
                        url: '/uploads/thumbnail_Easy_Bit_logo_342eaf5425.png',
                    },
                },
                hash: 'Easy_Bit_logo_342eaf5425',
                ext: '.png',
                mime: 'image/png',
                size: 3.2,
                url: '/uploads/Easy_Bit_logo_342eaf5425.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-10-21T22:58:36.000Z',
                updated_at: '2022-10-21T22:58:36.000Z',
            },
        ],
        score: 80,
    },
    {
        id: 7,
        name: 'Changelly',
        published_at: '2023-01-10T12:02:41.000Z',
        created_at: '2023-01-10T12:00:45.000Z',
        updated_at: '2023-02-20T10:58:21.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 10,
        decimal_place: 2,
        ecash_deposit_address_format: true,
        url: 'https://changelly.com/?from=btc&to=xec&utm_medium=social&utm_source=twitter&utm_campaign=listing',
        logo: [
            {
                id: 96,
                name: 'horizontal-changelly-logo-4.png',
                alternativeText: '',
                caption: '',
                width: 770,
                height: 200,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_horizontal-changelly-logo-4.png',
                        hash: 'thumbnail_horizontal_changelly_logo_4_d605d09204',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 64,
                        size: 7.13,
                        path: null,
                        url: '/uploads/thumbnail_horizontal_changelly_logo_4_d605d09204.png',
                    },
                    medium: {
                        name: 'medium_horizontal-changelly-logo-4.png',
                        hash: 'medium_horizontal_changelly_logo_4_d605d09204',
                        ext: '.png',
                        mime: 'image/png',
                        width: 750,
                        height: 195,
                        size: 31.59,
                        path: null,
                        url: '/uploads/medium_horizontal_changelly_logo_4_d605d09204.png',
                    },
                    small: {
                        name: 'small_horizontal-changelly-logo-4.png',
                        hash: 'small_horizontal_changelly_logo_4_d605d09204',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 130,
                        size: 18.56,
                        path: null,
                        url: '/uploads/small_horizontal_changelly_logo_4_d605d09204.png',
                    },
                },
                hash: 'horizontal_changelly_logo_4_d605d09204',
                ext: '.png',
                mime: 'image/png',
                size: 10.92,
                url: '/uploads/horizontal_changelly_logo_4_d605d09204.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-01-10T12:02:36.000Z',
                updated_at: '2023-01-10T12:02:36.000Z',
            },
        ],
        score: 80,
    },
    {
        id: 8,
        name: 'Quickex',
        published_at: '2023-06-12T04:18:18.000Z',
        created_at: '2023-06-12T04:18:07.000Z',
        updated_at: '2023-06-12T04:18:30.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 1,
        decimal_place: 6,
        ecash_deposit_address_format: true,
        url: 'https://quickex.io/exchange-xec-usdt',
        logo: [
            {
                id: 117,
                name: 'Quickex.png',
                alternativeText: '',
                caption: '',
                width: 458,
                height: 138,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_Quickex.png',
                        hash: 'thumbnail_Quickex_bfc370a633',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 74,
                        size: 7.82,
                        path: null,
                        url: '/uploads/thumbnail_Quickex_bfc370a633.png',
                    },
                },
                hash: 'Quickex_bfc370a633',
                ext: '.png',
                mime: 'image/png',
                size: 5.12,
                url: '/uploads/Quickex_bfc370a633.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-06-12T04:15:09.000Z',
                updated_at: '2023-06-12T04:15:09.000Z',
            },
        ],
        score: 90,
    },
];

export const scoredMockServices = [
    {
        id: 1,
        name: 'be.cash',
        url: 'https://explorer.be.cash/blocks',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:13:05.000Z',
        created_at: '2022-02-16T19:13:04.000Z',
        updated_at: '2022-10-21T11:08:42.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 7,
                name: 'be-cash.png',
                alternativeText: 'be.cash',
                caption: '',
                width: 518,
                height: 205,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_be-cash.png',
                        hash: 'thumbnail_be_cash_aa364bfcb7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 97,
                        size: 7.3,
                        path: null,
                        url: '/uploads/thumbnail_be_cash_aa364bfcb7.png',
                    },
                    small: {
                        name: 'small_be-cash.png',
                        hash: 'small_be_cash_aa364bfcb7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 198,
                        size: 18.35,
                        path: null,
                        url: '/uploads/small_be_cash_aa364bfcb7.png',
                    },
                },
                hash: 'be_cash_aa364bfcb7',
                ext: '.png',
                mime: 'image/png',
                size: 4.95,
                url: '/uploads/be_cash_aa364bfcb7.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:49.000Z',
                updated_at: '2022-10-21T11:08:39.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 2,
        name: 'Blockchair',
        url: 'https://blockchair.com/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: "Stating that more than 1 confirmation is required for finalization and using 'ECash' instead of 'eCash' on the tooltip.",
        published_at: '2022-02-16T19:14:56.000Z',
        created_at: '2022-02-16T19:14:50.000Z',
        updated_at: '2022-10-21T11:10:00.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 12,
                name: 'blockchair.png',
                alternativeText: 'Blockchair',
                caption: '',
                width: 500,
                height: 134,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_blockchair.png',
                        hash: 'thumbnail_blockchair_d20f851724',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 66,
                        size: 5.27,
                        path: null,
                        url: '/uploads/thumbnail_blockchair_d20f851724.png',
                    },
                },
                hash: 'blockchair_d20f851724',
                ext: '.png',
                mime: 'image/png',
                size: 3.24,
                url: '/uploads/blockchair_d20f851724.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:50.000Z',
                updated_at: '2022-10-21T11:09:58.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 3,
        name: 'Coin Dance',
        url: 'https://ecash.coin.dance/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-07-27T13:22:25.000Z',
        created_at: '2022-02-16T19:15:36.000Z',
        updated_at: '2022-10-21T11:10:28.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 72,
                name: 'coin-dance.png',
                alternativeText: 'Coin Dance',
                caption: '',
                width: 500,
                height: 102,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coin-dance.png',
                        hash: 'thumbnail_coin_dance_e17caff117',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 50,
                        size: 4.78,
                        path: null,
                        url: '/uploads/thumbnail_coin_dance_e17caff117.png',
                    },
                },
                hash: 'coin_dance_e17caff117',
                ext: '.png',
                mime: 'image/png',
                size: 2.21,
                url: '/uploads/coin_dance_e17caff117.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-07-27T13:24:41.000Z',
                updated_at: '2022-10-21T11:10:26.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 4,
        name: 'CoinGecko',
        url: 'https://www.coingecko.com/en/coins/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:16:19.000Z',
        created_at: '2022-02-16T19:16:18.000Z',
        updated_at: '2022-10-21T11:10:58.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 21,
                name: 'coingecko.png',
                alternativeText: 'CoinGecko',
                caption: '',
                width: 500,
                height: 151,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coingecko.png',
                        hash: 'thumbnail_coingecko_7d6f520f55',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 74,
                        size: 7.1,
                        path: null,
                        url: '/uploads/thumbnail_coingecko_7d6f520f55.png',
                    },
                },
                hash: 'coingecko_7d6f520f55',
                ext: '.png',
                mime: 'image/png',
                size: 5.16,
                url: '/uploads/coingecko_7d6f520f55.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:10:56.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 5,
        name: 'CoinMarketCap',
        url: 'https://coinmarketcap.com/currencies/ecash/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:17:20.000Z',
        created_at: '2022-02-16T19:17:18.000Z',
        updated_at: '2022-10-21T11:11:13.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 22,
                name: 'coinmarketcap.png',
                alternativeText: 'CoinMarketCap',
                caption: '',
                width: 500,
                height: 98,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coinmarketcap.png',
                        hash: 'thumbnail_coinmarketcap_86fb1e6629',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 48,
                        size: 5.71,
                        path: null,
                        url: '/uploads/thumbnail_coinmarketcap_86fb1e6629.png',
                    },
                },
                hash: 'coinmarketcap_86fb1e6629',
                ext: '.png',
                mime: 'image/png',
                size: 4.16,
                url: '/uploads/coinmarketcap_86fb1e6629.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:11:10.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 6,
        name: 'Livecoinwatch',
        url: 'https://www.livecoinwatch.com/price/eCash-XEC',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:17:59.000Z',
        created_at: '2022-02-16T19:17:59.000Z',
        updated_at: '2022-10-21T11:11:53.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 52,
                name: 'livecoinwatch.png',
                alternativeText: 'Live Coin Watch',
                caption: '',
                width: 600,
                height: 77,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_livecoinwatch.png',
                        hash: 'thumbnail_livecoinwatch_3fec7e3a6c',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 31,
                        size: 4.36,
                        path: null,
                        url: '/uploads/thumbnail_livecoinwatch_3fec7e3a6c.png',
                    },
                    small: {
                        name: 'small_livecoinwatch.png',
                        hash: 'small_livecoinwatch_3fec7e3a6c',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 64,
                        size: 10.82,
                        path: null,
                        url: '/uploads/small_livecoinwatch_3fec7e3a6c.png',
                    },
                },
                hash: 'livecoinwatch_3fec7e3a6c',
                ext: '.png',
                mime: 'image/png',
                size: 4.01,
                url: '/uploads/livecoinwatch_3fec7e3a6c.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-10-21T11:11:50.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 7,
        name: 'feixiaohao.com',
        url: 'https://www.feixiaohaozh.info/currencies/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: '',
        published_at: '2022-02-16T19:19:21.000Z',
        created_at: '2022-02-16T19:19:20.000Z',
        updated_at: '2023-06-09T05:40:22.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 25,
                name: 'feixiaohao-com.png',
                alternativeText: 'feixiaohao',
                caption: '',
                width: 500,
                height: 120,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_feixiaohao-com.png',
                        hash: 'thumbnail_feixiaohao_com_b8f00e03d7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 59,
                        size: 5.62,
                        path: null,
                        url: '/uploads/thumbnail_feixiaohao_com_b8f00e03d7.png',
                    },
                },
                hash: 'feixiaohao_com_b8f00e03d7',
                ext: '.png',
                mime: 'image/png',
                size: 2.91,
                url: '/uploads/feixiaohao_com_b8f00e03d7.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:11:32.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 8,
        name: 'ViaWallet Explorer',
        url: 'https://explorer.viawallet.com/xec',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 8,
        issues: null,
        published_at: '2022-02-16T19:20:45.000Z',
        created_at: '2022-02-16T19:20:13.000Z',
        updated_at: '2022-02-16T19:20:45.000Z',
        fiat_deposit_options: null,
        logo: [
            {
                id: 58,
                name: 'viawallet-explorer.png',
                alternativeText: '',
                caption: '',
                width: 400,
                height: 84,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_viawallet-explorer.png',
                        hash: 'thumbnail_viawallet_explorer_36e2f5944b',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 51,
                        size: 6.99,
                        path: null,
                        url: '/uploads/thumbnail_viawallet_explorer_36e2f5944b.png',
                    },
                },
                hash: 'viawallet_explorer_36e2f5944b',
                ext: '.png',
                mime: 'image/png',
                size: 6.63,
                url: '/uploads/viawallet_explorer_36e2f5944b.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-02-10T21:24:53.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 9,
        name: 'CoinCap.io',
        url: 'https://coincap.io/assets/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: null,
        issues: 'Missing key exchange trading pairs (Upbit, Bithumb, etc).',
        published_at: '2022-02-16T19:21:34.000Z',
        created_at: '2022-02-16T19:21:33.000Z',
        updated_at: '2022-10-21T11:10:43.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 20,
                name: 'coincap-io.png',
                alternativeText: 'CoinCap',
                caption: '',
                width: 500,
                height: 219,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coincap-io.png',
                        hash: 'thumbnail_coincap_io_5bbe710c86',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 107,
                        size: 7.07,
                        path: null,
                        url: '/uploads/thumbnail_coincap_io_5bbe710c86.png',
                    },
                },
                hash: 'coincap_io_5bbe710c86',
                ext: '.png',
                mime: 'image/png',
                size: 4.4,
                url: '/uploads/coincap_io_5bbe710c86.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:10:42.000Z',
            },
        ],
        score: 40,
    },
    {
        id: 10,
        name: 'Matrixport',
        url: 'https://www.matrixport.com/en',
        ecash_brand: true,
        ecash_address_format: false,
        decimal_place: 2,
        issues: 'No proper eCash services (only supporting deposit and withdrawal) and a high withdrawal fee of 10,000 bits (XEC).',
        published_at: '2022-02-16T19:26:32.000Z',
        created_at: '2022-02-16T19:26:30.000Z',
        updated_at: '2022-02-18T21:39:29.000Z',
        fiat_deposit_options: null,
        logo: [
            {
                id: 44,
                name: 'matrixport.png',
                alternativeText: '',
                caption: '',
                width: 400,
                height: 83,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_matrixport.png',
                        hash: 'thumbnail_matrixport_b76e44ecb7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 51,
                        size: 5.57,
                        path: null,
                        url: '/uploads/thumbnail_matrixport_b76e44ecb7.png',
                    },
                },
                hash: 'matrixport_b76e44ecb7',
                ext: '.png',
                mime: 'image/png',
                size: 5.33,
                url: '/uploads/matrixport_b76e44ecb7.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-02-10T21:24:52.000Z',
            },
        ],
        score: 30,
    },
    {
        id: 13,
        name: 'Cashtab',
        url: 'https://cashtab.com/#/wallet',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-09-26T00:08:06.000Z',
        created_at: '2022-09-26T00:01:31.000Z',
        updated_at: '2022-10-21T11:10:14.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 79,
                name: 'cashtab_xec.png',
                alternativeText: 'Cashtab',
                caption: '',
                width: 710,
                height: 125,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_cashtab_xec.png',
                        hash: 'thumbnail_cashtab_xec_37da0eae8e',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 43,
                        size: 7.31,
                        path: null,
                        url: '/uploads/thumbnail_cashtab_xec_37da0eae8e.png',
                    },
                    small: {
                        name: 'small_cashtab_xec.png',
                        hash: 'small_cashtab_xec_37da0eae8e',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 88,
                        size: 17.29,
                        path: null,
                        url: '/uploads/small_cashtab_xec_37da0eae8e.png',
                    },
                },
                hash: 'cashtab_xec_37da0eae8e',
                ext: '.png',
                mime: 'image/png',
                size: 6.29,
                url: '/uploads/cashtab_xec_37da0eae8e.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-09-26T00:04:55.000Z',
                updated_at: '2022-10-21T11:10:12.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 14,
        name: 'SwapSpace',
        url: 'https://swapspace.co/?to=xec&amount=1',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 5,
        issues: null,
        published_at: '2022-11-16T05:23:35.000Z',
        created_at: '2022-11-16T05:21:55.000Z',
        updated_at: '2022-11-16T05:23:35.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 87,
                name: 'SwapSpaceLogoBlackStacked.svg',
                alternativeText: '',
                caption: '',
                width: 710,
                height: 246,
                formats: null,
                hash: 'Swap_Space_Logo_Black_Stacked_98c54408f7',
                ext: '.svg',
                mime: 'image/svg+xml',
                size: 3.86,
                url: '/uploads/Swap_Space_Logo_Black_Stacked_98c54408f7.svg',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-11-16T05:21:49.000Z',
                updated_at: '2022-11-16T05:21:49.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 15,
        name: 'Swapzone',
        url: 'https://swapzone.io/exchange/eth/xec',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 8,
        issues: null,
        published_at: '2022-11-16T05:29:20.000Z',
        created_at: '2022-11-16T05:27:04.000Z',
        updated_at: '2022-11-16T05:29:20.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 88,
                name: 'Swapzone logo (1).svg',
                alternativeText: '',
                caption: '',
                width: 240,
                height: 88,
                formats: null,
                hash: 'Swapzone_logo_1_25d2ec1093',
                ext: '.svg',
                mime: 'image/svg+xml',
                size: 4.59,
                url: '/uploads/Swapzone_logo_1_25d2ec1093.svg',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-11-16T05:27:00.000Z',
                updated_at: '2022-11-16T05:27:00.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 17,
        name: 'PayButton',
        url: 'https://paybutton.org/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T01:32:32.000Z',
        created_at: '2023-02-17T01:31:38.000Z',
        updated_at: '2023-02-17T01:32:32.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 101,
                name: 'pbLogoNoBorder_white.png',
                alternativeText: '',
                caption: '',
                width: 600,
                height: 112,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_pbLogoNoBorder_white.png',
                        hash: 'thumbnail_pb_Logo_No_Border_white_4821b0d3fd',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 46,
                        size: 5.6,
                        path: null,
                        url: '/uploads/thumbnail_pb_Logo_No_Border_white_4821b0d3fd.png',
                    },
                    small: {
                        name: 'small_pbLogoNoBorder_white.png',
                        hash: 'small_pb_Logo_No_Border_white_4821b0d3fd',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 93,
                        size: 12.41,
                        path: null,
                        url: '/uploads/small_pb_Logo_No_Border_white_4821b0d3fd.png',
                    },
                },
                hash: 'pb_Logo_No_Border_white_4821b0d3fd',
                ext: '.png',
                mime: 'image/png',
                size: 3.68,
                url: '/uploads/pb_Logo_No_Border_white_4821b0d3fd.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T01:31:30.000Z',
                updated_at: '2023-02-17T01:31:30.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 18,
        name: 'Gorbeious',
        url: 'https://gorbeious.cash/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T08:54:11.000Z',
        created_at: '2023-02-17T08:52:27.000Z',
        updated_at: '2023-02-17T17:03:46.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 112,
                name: 'gorbeious.png',
                alternativeText: '',
                caption: '',
                width: 600,
                height: 132,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_gorbeious.png',
                        hash: 'thumbnail_gorbeious_fbc936deba',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 54,
                        size: 6.49,
                        path: null,
                        url: '/uploads/thumbnail_gorbeious_fbc936deba.png',
                    },
                    small: {
                        name: 'small_gorbeious.png',
                        hash: 'small_gorbeious_fbc936deba',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 110,
                        size: 17.2,
                        path: null,
                        url: '/uploads/small_gorbeious_fbc936deba.png',
                    },
                },
                hash: 'gorbeious_fbc936deba',
                ext: '.png',
                mime: 'image/png',
                size: 4.74,
                url: '/uploads/gorbeious_fbc936deba.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T17:03:37.000Z',
                updated_at: '2023-02-17T17:03:37.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 19,
        name: 'Cert.cash',
        url: 'https://cert.cash/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T09:13:18.000Z',
        created_at: '2023-02-17T09:13:15.000Z',
        updated_at: '2023-02-17T09:15:44.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 107,
                name: 'cert logo.png',
                alternativeText: '',
                caption: '',
                width: 513,
                height: 118,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_cert logo.png',
                        hash: 'thumbnail_cert_logo_949834d8bb',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 56,
                        size: 7.02,
                        path: null,
                        url: '/uploads/thumbnail_cert_logo_949834d8bb.png',
                    },
                    small: {
                        name: 'small_cert logo.png',
                        hash: 'small_cert_logo_949834d8bb',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 115,
                        size: 15.07,
                        path: null,
                        url: '/uploads/small_cert_logo_949834d8bb.png',
                    },
                },
                hash: 'cert_logo_949834d8bb',
                ext: '.png',
                mime: 'image/png',
                size: 5.4,
                url: '/uploads/cert_logo_949834d8bb.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T09:15:39.000Z',
                updated_at: '2023-02-17T09:15:39.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 20,
        name: 'Badger Universal Token',
        url: 'https://bux.digital/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T17:02:40.000Z',
        created_at: '2023-02-17T16:45:26.000Z',
        updated_at: '2023-02-17T17:09:44.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 110,
                name: 'BUX.Digital',
                alternativeText: 'Badger Universal Token',
                caption: '',
                width: 302,
                height: 48,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_BUX.Digital',
                        hash: 'thumbnail_bux_digital_7cb745f6ad',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 39,
                        size: 5.14,
                        path: null,
                        url: '/uploads/thumbnail_bux_digital_7cb745f6ad.png',
                    },
                },
                hash: 'bux_digital_7cb745f6ad',
                ext: '.png',
                mime: 'image/png',
                size: 2.63,
                url: '/uploads/bux_digital_7cb745f6ad.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T16:53:31.000Z',
                updated_at: '2023-02-24T11:10:40.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 23,
        name: 'Flashift',
        url: 'https://exchange.flashift.app/?currency_from=btc&currency_to=xec&amount=0.1',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 8,
        issues: null,
        published_at: '2023-05-03T12:40:30.000Z',
        created_at: '2023-05-03T12:39:35.000Z',
        updated_at: '2023-05-03T12:47:15.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 116,
                name: 'Flashift_-BigLogo.png',
                alternativeText: '',
                caption: '',
                width: 620,
                height: 310,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_Flashift_-BigLogo.png',
                        hash: 'thumbnail_Flashift_Big_Logo_d41607b8ce',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 123,
                        size: 8.88,
                        path: null,
                        url: '/uploads/thumbnail_Flashift_Big_Logo_d41607b8ce.png',
                    },
                    small: {
                        name: 'small_Flashift_-BigLogo.png',
                        hash: 'small_Flashift_Big_Logo_d41607b8ce',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 250,
                        size: 20.18,
                        path: null,
                        url: '/uploads/small_Flashift_Big_Logo_d41607b8ce.png',
                    },
                },
                hash: 'Flashift_Big_Logo_d41607b8ce',
                ext: '.png',
                mime: 'image/png',
                size: 17.31,
                url: '/uploads/Flashift_Big_Logo_d41607b8ce.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-05-03T12:42:17.000Z',
                updated_at: '2023-05-03T12:42:17.000Z',
            },
        ],
        score: 70,
    },
];

export const sortedMockExchanges = [
    {
        id: 5,
        name: 'CoinEx',
        published_at: '2022-02-10T23:16:37.000Z',
        created_at: '2022-02-10T23:16:34.000Z',
        updated_at: '2023-06-12T04:29:59.000Z',
        ecash_brand: true,
        decimal_places: 8,
        ecash_deposit_address_format: true,
        url: 'https://www.coinex.com/info/XEC',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT', 'USDC'],
        withdrawal_fee: 5,
        xec_withdrawal_fee: true,
        quirks_issues:
            "XEC/BTC pair needs to be added. They said they would figure out something for that but haven't given us an ETA. Also, they're requiring 120 confirmations to withdraw (and 20 to deposit) which seems like a lot.",
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 71,
            name: 'coinex.png',
            alternativeText: 'CoinEx',
            caption: '',
            width: 538,
            height: 173,
            formats: {
                thumbnail: {
                    name: 'thumbnail_coinex.png',
                    hash: 'thumbnail_coinex_7167e1c81d',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 79,
                    size: 8.13,
                    path: null,
                    url: '/uploads/thumbnail_coinex_7167e1c81d.png',
                },
                small: {
                    name: 'small_coinex.png',
                    hash: 'small_coinex_7167e1c81d',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 161,
                    size: 21.12,
                    path: null,
                    url: '/uploads/small_coinex_7167e1c81d.png',
                },
            },
            hash: 'coinex_7167e1c81d',
            ext: '.png',
            mime: 'image/png',
            size: 3.05,
            url: '/uploads/coinex_7167e1c81d.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-07-27T13:21:36.000Z',
            updated_at: '2022-10-21T08:22:59.000Z',
        },
        score: 95,
    },
    {
        id: 1,
        name: 'Binance',
        published_at: '2022-02-03T22:59:16.000Z',
        created_at: '2022-02-03T22:59:13.000Z',
        updated_at: '2022-11-18T20:36:19.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.binance.com/en/trade/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT', 'BUSD'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: true,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['EUR', 'GBP', 'NZD', 'RUB', 'TRY', 'UAH', 'USD'],
        logo: {
            id: 1,
            name: 'binance.png',
            alternativeText: 'Binance',
            caption: '',
            width: 249,
            height: 50,
            formats: {
                thumbnail: {
                    name: 'thumbnail_binance.png',
                    hash: 'thumbnail_binance_64d10b4b7d',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 49,
                    size: 6.31,
                    path: null,
                    url: '/uploads/thumbnail_binance_64d10b4b7d.png',
                },
            },
            hash: 'binance_64d10b4b7d',
            ext: '.png',
            mime: 'image/png',
            size: 3.39,
            url: '/uploads/binance_64d10b4b7d.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:07:22.000Z',
            updated_at: '2022-11-18T20:36:08.000Z',
        },
        score: 90,
    },
    {
        id: 33,
        name: 'SouthXchange',
        published_at: '2022-02-15T23:45:53.000Z',
        created_at: '2022-02-15T23:45:52.000Z',
        updated_at: '2022-12-21T05:54:25.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://main.southxchange.com/Market/Book/XEC/BTC',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['BTC'],
        withdrawal_fee: 3,
        xec_withdrawal_fee: null,
        quirks_issues:
            'We will enable deposits and withdrawals when we have a free server available to run the wallet. If you are able to sponsor a server then we can enable it asap. Otherwise it might take some time.',
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 48,
            name: 'southxchange.png',
            alternativeText: 'southXchange',
            caption: '',
            width: 334,
            height: 80,
            formats: {
                thumbnail: {
                    name: 'thumbnail_southxchange.png',
                    hash: 'thumbnail_southxchange_503b223a1e',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 59,
                    size: 6.08,
                    path: null,
                    url: '/uploads/thumbnail_southxchange_503b223a1e.png',
                },
            },
            hash: 'southxchange_503b223a1e',
            ext: '.png',
            mime: 'image/png',
            size: 2.17,
            url: '/uploads/southxchange_503b223a1e.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:32:52.000Z',
        },
        score: 90,
    },
    {
        id: 15,
        name: 'Bitfinex',
        published_at: '2022-02-15T22:16:26.000Z',
        created_at: '2022-02-15T22:16:25.000Z',
        updated_at: '2023-06-09T15:45:12.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://trading.bitfinex.com/t/XEC:USD',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USD'],
        withdrawal_fee: 0,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['USD', 'EUR', 'GBP', 'JPY', 'CNH'],
        logo: {
            id: 10,
            name: 'bitfinex.png',
            alternativeText: 'Bitfinex',
            caption: '',
            width: 422,
            height: 50,
            formats: {
                thumbnail: {
                    name: 'thumbnail_bitfinex.png',
                    hash: 'thumbnail_bitfinex_63accf2654',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 29,
                    size: 4.27,
                    path: null,
                    url: '/uploads/thumbnail_bitfinex_63accf2654.png',
                },
            },
            hash: 'bitfinex_63accf2654',
            ext: '.png',
            mime: 'image/png',
            size: 3.98,
            url: '/uploads/bitfinex_63accf2654.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2022-11-18T21:31:41.000Z',
        },
        score: 85,
    },
    {
        id: 25,
        name: 'gate.io',
        published_at: '2022-02-15T23:28:48.000Z',
        created_at: '2022-02-15T23:28:47.000Z',
        updated_at: '2023-04-22T01:30:59.000Z',
        ecash_brand: true,
        decimal_places: 3,
        ecash_deposit_address_format: true,
        url: 'https://www.gate.io/tw/trade/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 6,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['CNY', 'KRW', 'VND', 'USD', 'INR', 'TRY'],
        logo: {
            id: 73,
            name: 'gate-io.png',
            alternativeText: '',
            caption: '',
            width: 400,
            height: 100,
            formats: {
                thumbnail: {
                    name: 'thumbnail_gate-io.png',
                    hash: 'thumbnail_gate_io_793eef8007',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 61,
                    size: 7.01,
                    path: null,
                    url: '/uploads/thumbnail_gate_io_793eef8007.png',
                },
            },
            hash: 'gate_io_793eef8007',
            ext: '.png',
            mime: 'image/png',
            size: 3.07,
            url: '/uploads/gate_io_793eef8007.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-07-27T13:28:57.000Z',
            updated_at: '2022-10-21T08:26:54.000Z',
        },
        score: 85,
    },
    {
        id: 20,
        name: 'Huobi',
        published_at: '2023-01-10T21:27:20.000Z',
        created_at: '2022-02-15T22:33:53.000Z',
        updated_at: '2023-01-10T21:27:20.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://www.huobi.com/en-in/exchange/xec_usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: "Don't want to use the new address format",
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['60+ Currencies through Visa/Mastercard'],
        logo: {
            id: 37,
            name: 'huobi.png',
            alternativeText: 'Huobi',
            caption: '',
            width: 500,
            height: 152,
            formats: {
                thumbnail: {
                    name: 'thumbnail_huobi.png',
                    hash: 'thumbnail_huobi_cfbdcdb9d7',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 74,
                    size: 6.73,
                    path: null,
                    url: '/uploads/thumbnail_huobi_cfbdcdb9d7.png',
                },
            },
            hash: 'huobi_cfbdcdb9d7',
            ext: '.png',
            mime: 'image/png',
            size: 4.66,
            url: '/uploads/huobi_cfbdcdb9d7.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:28:20.000Z',
        },
        score: 85,
    },
    {
        id: 41,
        name: 'Bitrue',
        published_at: '2022-08-05T18:33:31.000Z',
        created_at: '2022-08-05T18:23:47.000Z',
        updated_at: '2022-12-08T06:43:36.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.bitrue.com/trade/xec_usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 82,
            name: 'Bitrue_44093e2318.png',
            alternativeText: '',
            caption: '',
            width: 597,
            height: 163,
            formats: {
                thumbnail: {
                    name: 'thumbnail_Bitrue_44093e2318.png',
                    hash: 'thumbnail_Bitrue_44093e2318_ef5bb48b0b',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 67,
                    size: 7.28,
                    path: null,
                    url: '/uploads/thumbnail_Bitrue_44093e2318_ef5bb48b0b.png',
                },
                small: {
                    name: 'small_Bitrue_44093e2318.png',
                    hash: 'small_Bitrue_44093e2318_ef5bb48b0b',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 137,
                    size: 17.07,
                    path: null,
                    url: '/uploads/small_Bitrue_44093e2318_ef5bb48b0b.png',
                },
            },
            hash: 'Bitrue_44093e2318_ef5bb48b0b',
            ext: '.png',
            mime: 'image/png',
            size: 4.98,
            url: '/uploads/Bitrue_44093e2318_ef5bb48b0b.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-10-21T08:17:27.000Z',
            updated_at: '2022-10-21T08:17:27.000Z',
        },
        score: 80,
    },
    {
        id: 8,
        name: 'Indodax',
        published_at: '2022-02-10T23:37:32.000Z',
        created_at: '2022-02-10T23:37:30.000Z',
        updated_at: '2022-11-15T13:28:40.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://indodax.com/market/XECUSDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['IDR'],
        logo: {
            id: 38,
            name: 'indodax.png',
            alternativeText: 'Indodax',
            caption: '',
            width: 500,
            height: 102,
            formats: {
                thumbnail: {
                    name: 'thumbnail_indodax.png',
                    hash: 'thumbnail_indodax_d61d9ee106',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 50,
                    size: 8.67,
                    path: null,
                    url: '/uploads/thumbnail_indodax_d61d9ee106.png',
                },
            },
            hash: 'indodax_d61d9ee106',
            ext: '.png',
            mime: 'image/png',
            size: 7.22,
            url: '/uploads/indodax_d61d9ee106.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:28:39.000Z',
        },
        score: 80,
    },
    {
        id: 18,
        name: 'LBank',
        published_at: '2022-02-15T22:21:38.000Z',
        created_at: '2022-02-15T22:21:37.000Z',
        updated_at: '2023-01-31T18:54:03.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.lbank.info/exchange/xec/usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 1,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1500,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 99,
            name: '189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
            alternativeText: '',
            caption: '',
            width: 2480,
            height: 704,
            formats: {
                thumbnail: {
                    name: 'thumbnail_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'thumbnail_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 70,
                    size: 5.36,
                    path: null,
                    url: '/uploads/thumbnail_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
                large: {
                    name: 'large_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'large_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 1000,
                    height: 284,
                    size: 23.64,
                    path: null,
                    url: '/uploads/large_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
                medium: {
                    name: 'medium_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'medium_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 213,
                    size: 17.08,
                    path: null,
                    url: '/uploads/medium_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
                small: {
                    name: 'small_189f3dc9-4d20-4659-96fe-fe41ceb37505 (1).png',
                    hash: 'small_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 142,
                    size: 11.01,
                    path: null,
                    url: '/uploads/small_189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
                },
            },
            hash: '189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2',
            ext: '.png',
            mime: 'image/png',
            size: 5.68,
            url: '/uploads/189f3dc9_4d20_4659_96fe_fe41ceb37505_1_7216adb6e2.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2023-01-31T06:55:12.000Z',
            updated_at: '2023-01-31T06:55:12.000Z',
        },
        score: 75,
    },
    {
        id: 43,
        name: 'FMFW.io',
        published_at: '2022-11-14T10:26:44.000Z',
        created_at: '2022-11-14T09:00:15.000Z',
        updated_at: '2022-12-16T13:14:19.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://fmfw.io/xec-to-usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 5,
        trading_pairs: ['USDT', 'BTC'],
        withdrawal_fee: 8660,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 86,
            name: 'IMG_20221114_175356_215.png',
            alternativeText: '',
            caption: '',
            width: 234,
            height: 50,
            formats: {},
            hash: 'IMG_20221114_175356_215_607f24f2e2',
            ext: '.png',
            mime: 'image/png',
            size: 2.86,
            url: '/uploads/IMG_20221114_175356_215_607f24f2e2.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-11-14T08:55:16.000Z',
            updated_at: '2022-11-18T21:19:47.000Z',
        },
        score: 75,
    },
    {
        id: 21,
        name: 'MEXC',
        published_at: '2022-02-15T22:38:47.000Z',
        created_at: '2022-02-15T22:38:45.000Z',
        updated_at: '2023-02-16T08:53:26.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://www.mexc.com/exchange/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 2,
        trading_pairs: ['USDT'],
        withdrawal_fee: 2000,
        xec_withdrawal_fee: null,
        quirks_issues: 'Using legacy (BTC) address format for deposits',
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'AED',
            'AUD',
            'BDT',
            'BRL',
            'CAD',
            'EGP',
            'EUR',
            'GBP',
            'GHS',
            'IDR',
            'INR',
            'JPY',
            'KRW',
            'KZT',
            'MYR',
            'MMK',
            'TWD',
            'NGN',
            'PHP',
            'PKR',
            'RUB',
            'TZS',
            'THB',
            'TRY',
            'UAH',
            'USD',
            'VES',
            'VND',
        ],
        logo: {
            id: 55,
            name: 'mexc.png',
            alternativeText: 'MEXC',
            caption: '',
            width: 1586,
            height: 356,
            formats: {
                thumbnail: {
                    name: 'thumbnail_mexc.png',
                    hash: 'thumbnail_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 55,
                    size: 7.82,
                    path: null,
                    url: '/uploads/thumbnail_mexc_f3083ac0c3.png',
                },
                large: {
                    name: 'large_mexc.png',
                    hash: 'large_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 1000,
                    height: 224,
                    size: 42.92,
                    path: null,
                    url: '/uploads/large_mexc_f3083ac0c3.png',
                },
                medium: {
                    name: 'medium_mexc.png',
                    hash: 'medium_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 168,
                    size: 32.96,
                    path: null,
                    url: '/uploads/medium_mexc_f3083ac0c3.png',
                },
                small: {
                    name: 'small_mexc.png',
                    hash: 'small_mexc_f3083ac0c3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 112,
                    size: 19.21,
                    path: null,
                    url: '/uploads/small_mexc_f3083ac0c3.png',
                },
            },
            hash: 'mexc_f3083ac0c3',
            ext: '.png',
            mime: 'image/png',
            size: 6.34,
            url: '/uploads/mexc_f3083ac0c3.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:31:31.000Z',
        },
        score: 65,
    },
    {
        id: 46,
        name: 'Bitbarg ',
        published_at: '2022-12-21T19:39:01.000Z',
        created_at: '2022-12-21T18:49:54.000Z',
        updated_at: '2022-12-22T03:05:47.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://bitbarg.com/',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 6,
        trading_pairs: ['IRR'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['IRR'],
        logo: {
            id: 95,
            name: 'Bitbarg.svg',
            alternativeText: '',
            caption: '',
            width: 209,
            height: 68,
            formats: null,
            hash: 'Bitbarg_0b2e57f56e',
            ext: '.svg',
            mime: 'image/svg+xml',
            size: 4.94,
            url: '/uploads/Bitbarg_0b2e57f56e.svg',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-12-21T19:41:05.000Z',
            updated_at: '2022-12-21T19:41:05.000Z',
        },
        score: 65,
    },
    {
        id: 24,
        name: 'Coinone',
        published_at: '2022-02-15T23:27:21.000Z',
        created_at: '2022-02-15T23:27:20.000Z',
        updated_at: '2022-10-21T08:23:22.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://coinone.co.kr/exchange/trade/xec/krw',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 10,
        trading_pairs: ['KRW'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 26,
            name: 'coinone.png',
            alternativeText: 'Coinone',
            caption: '',
            width: 664,
            height: 130,
            formats: {
                thumbnail: {
                    name: 'thumbnail_coinone.png',
                    hash: 'thumbnail_coinone_d6e3fa4fd3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 48,
                    size: 6.08,
                    path: null,
                    url: '/uploads/thumbnail_coinone_d6e3fa4fd3.png',
                },
                small: {
                    name: 'small_coinone.png',
                    hash: 'small_coinone_d6e3fa4fd3',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 98,
                    size: 14.44,
                    path: null,
                    url: '/uploads/small_coinone_d6e3fa4fd3.png',
                },
            },
            hash: 'coinone_d6e3fa4fd3',
            ext: '.png',
            mime: 'image/png',
            size: 3.55,
            url: '/uploads/coinone_d6e3fa4fd3.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:51.000Z',
            updated_at: '2022-10-21T08:23:19.000Z',
        },
        score: 65,
    },
    {
        id: 19,
        name: 'Poloniex',
        published_at: '2022-02-15T22:22:47.000Z',
        created_at: '2022-02-15T22:22:45.000Z',
        updated_at: '2022-10-21T08:32:37.000Z',
        ecash_brand: true,
        decimal_places: 8,
        ecash_deposit_address_format: true,
        url: 'https://poloniex.com/spot/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 10,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'Supports 40+ fiat currencies through Simplex payment partner',
        ],
        logo: {
            id: 76,
            name: 'poloniex_logo-freelogovectors.net_.png',
            alternativeText: 'Poloniex',
            caption: '',
            width: 1423,
            height: 365,
            formats: {
                thumbnail: {
                    name: 'thumbnail_poloniex_logo-freelogovectors.net_.png',
                    hash: 'thumbnail_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 63,
                    size: 6.65,
                    path: null,
                    url: '/uploads/thumbnail_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
                large: {
                    name: 'large_poloniex_logo-freelogovectors.net_.png',
                    hash: 'large_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 1000,
                    height: 257,
                    size: 29.92,
                    path: null,
                    url: '/uploads/large_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
                medium: {
                    name: 'medium_poloniex_logo-freelogovectors.net_.png',
                    hash: 'medium_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 192,
                    size: 21.87,
                    path: null,
                    url: '/uploads/medium_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
                small: {
                    name: 'small_poloniex_logo-freelogovectors.net_.png',
                    hash: 'small_poloniex_logo_freelogovectors_net_f835d8039a',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 128,
                    size: 14.21,
                    path: null,
                    url: '/uploads/small_poloniex_logo_freelogovectors_net_f835d8039a.png',
                },
            },
            hash: 'poloniex_logo_freelogovectors_net_f835d8039a',
            ext: '.png',
            mime: 'image/png',
            size: 4.76,
            url: '/uploads/poloniex_logo_freelogovectors_net_f835d8039a.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-08-18T06:25:06.000Z',
            updated_at: '2022-10-21T08:32:32.000Z',
        },
        score: 65,
    },
    {
        id: 14,
        name: 'Korbit',
        published_at: '2022-02-15T22:14:34.000Z',
        created_at: '2022-02-15T22:14:33.000Z',
        updated_at: '2022-10-21T08:29:22.000Z',
        ecash_brand: true,
        decimal_places: 2,
        ecash_deposit_address_format: true,
        url: 'https://exchange.korbit.co.kr/markets/?market=xec-krw',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 12,
        trading_pairs: ['KRW'],
        withdrawal_fee: 10000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 40,
            name: 'korbit.png',
            alternativeText: 'Korbit',
            caption: '',
            width: 500,
            height: 156,
            formats: {
                thumbnail: {
                    name: 'thumbnail_korbit.png',
                    hash: 'thumbnail_korbit_c7f68f9a00',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 76,
                    size: 6.34,
                    path: null,
                    url: '/uploads/thumbnail_korbit_c7f68f9a00.png',
                },
            },
            hash: 'korbit_c7f68f9a00',
            ext: '.png',
            mime: 'image/png',
            size: 3.5,
            url: '/uploads/korbit_c7f68f9a00.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:29:19.000Z',
        },
        score: 65,
    },
    {
        id: 4,
        name: 'Bithumb',
        published_at: '2022-02-10T21:27:11.000Z',
        created_at: '2022-02-10T21:27:09.000Z',
        updated_at: '2022-10-21T08:16:34.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://en.bithumb.com/trade/order/XEC_KRW',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 30,
        trading_pairs: ['KRW'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: true,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 14,
            name: 'bithumb.png',
            alternativeText: 'Bithumb',
            caption: '',
            width: 634,
            height: 192,
            formats: {
                thumbnail: {
                    name: 'thumbnail_bithumb.png',
                    hash: 'thumbnail_bithumb_e7d49b0753',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 74,
                    size: 7.08,
                    path: null,
                    url: '/uploads/thumbnail_bithumb_e7d49b0753.png',
                },
                small: {
                    name: 'small_bithumb.png',
                    hash: 'small_bithumb_e7d49b0753',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 151,
                    size: 15.98,
                    path: null,
                    url: '/uploads/small_bithumb_e7d49b0753.png',
                },
            },
            hash: 'bithumb_e7d49b0753',
            ext: '.png',
            mime: 'image/png',
            size: 1.81,
            url: '/uploads/bithumb_e7d49b0753.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2022-10-21T08:16:31.000Z',
        },
        score: 65,
    },
    {
        id: 27,
        name: 'OKX',
        published_at: '2022-02-15T23:31:12.000Z',
        created_at: '2022-02-15T23:31:11.000Z',
        updated_at: '2023-04-17T05:40:00.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.okex.com/markets/prices/ecash-xec',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 30,
        trading_pairs: ['USDT'],
        withdrawal_fee: 800,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'Supports 90+ fiat currencies via credit card/debit card/wire transfer/paypal and more.',
        ],
        logo: {
            id: 43,
            name: 'okx.png',
            alternativeText: 'OKX',
            caption: '',
            width: 164,
            height: 72,
            formats: {},
            hash: 'okx_59b3b0c033',
            ext: '.png',
            mime: 'image/png',
            size: 0.22,
            url: '/uploads/okx_59b3b0c033.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:31:45.000Z',
        },
        score: 65,
    },
    {
        id: 17,
        name: 'UPbit',
        published_at: '2022-02-15T22:19:41.000Z',
        created_at: '2022-02-15T22:19:40.000Z',
        updated_at: '2022-10-21T08:33:29.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://upbit.com/exchange?code=CRIX.UPBIT.KRW-XEC',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 30,
        trading_pairs: ['KRW'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['KRW'],
        logo: {
            id: 57,
            name: 'upbit.png',
            alternativeText: 'UPBit',
            caption: '',
            width: 490,
            height: 154,
            formats: {
                thumbnail: {
                    name: 'thumbnail_upbit.png',
                    hash: 'thumbnail_upbit_098ce8e0b6',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 77,
                    size: 5.05,
                    path: null,
                    url: '/uploads/thumbnail_upbit_098ce8e0b6.png',
                },
            },
            hash: 'upbit_098ce8e0b6',
            ext: '.png',
            mime: 'image/png',
            size: 0.82,
            url: '/uploads/upbit_098ce8e0b6.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:33:27.000Z',
        },
        score: 65,
    },
    {
        id: 30,
        name: 'BKEX',
        published_at: '2022-02-15T23:36:07.000Z',
        created_at: '2022-02-15T23:36:05.000Z',
        updated_at: '2022-11-18T21:32:10.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.bkex.com/trade/XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 60,
        trading_pairs: ['USDT'],
        withdrawal_fee: 1000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: ['THB'],
        logo: {
            id: 15,
            name: 'bkex.png',
            alternativeText: 'Bkex',
            caption: '',
            width: 168,
            height: 48,
            formats: {},
            hash: 'bkex_1f3d977204',
            ext: '.png',
            mime: 'image/png',
            size: 1.32,
            url: '/uploads/bkex_1f3d977204.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2023-02-17T07:35:36.000Z',
        },
        score: 65,
    },
    {
        id: 13,
        name: 'Hotbit',
        published_at: '2022-10-01T04:45:37.000Z',
        created_at: '2022-02-15T22:13:04.000Z',
        updated_at: '2022-12-09T11:42:34.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.hotbit.io/exchange?symbol=XEC_USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 2,
        trading_pairs: ['USDT'],
        withdrawal_fee: 5000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 35,
            name: 'hotbit.png',
            alternativeText: 'Hotbit',
            caption: '',
            width: 500,
            height: 138,
            formats: {
                thumbnail: {
                    name: 'thumbnail_hotbit.png',
                    hash: 'thumbnail_hotbit_3edd0cc911',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 68,
                    size: 6.19,
                    path: null,
                    url: '/uploads/thumbnail_hotbit_3edd0cc911.png',
                },
            },
            hash: 'hotbit_3edd0cc911',
            ext: '.png',
            mime: 'image/png',
            size: 4.56,
            url: '/uploads/hotbit_3edd0cc911.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:51.000Z',
            updated_at: '2022-10-21T08:27:19.000Z',
        },
        score: 60,
    },
    {
        id: 16,
        name: 'KUCOIN',
        published_at: '2022-02-15T22:18:15.000Z',
        created_at: '2022-02-15T22:18:13.000Z',
        updated_at: '2022-10-21T08:29:51.000Z',
        ecash_brand: true,
        decimal_places: 4,
        ecash_deposit_address_format: true,
        url: 'https://trade.kucoin.com/trade/XEC-USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 6,
        trading_pairs: ['USDT'],
        withdrawal_fee: 5000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 50,
            name: 'kucoin.png',
            alternativeText: 'KuCoin',
            caption: '',
            width: 600,
            height: 150,
            formats: {
                thumbnail: {
                    name: 'thumbnail_kucoin.png',
                    hash: 'thumbnail_kucoin_cbf360cb43',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 61,
                    size: 6.4,
                    path: null,
                    url: '/uploads/thumbnail_kucoin_cbf360cb43.png',
                },
                small: {
                    name: 'small_kucoin.png',
                    hash: 'small_kucoin_cbf360cb43',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 125,
                    size: 15.18,
                    path: null,
                    url: '/uploads/small_kucoin_cbf360cb43.png',
                },
            },
            hash: 'kucoin_cbf360cb43',
            ext: '.png',
            mime: 'image/png',
            size: 2.67,
            url: '/uploads/kucoin_cbf360cb43.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:52.000Z',
            updated_at: '2022-10-21T08:29:48.000Z',
        },
        score: 60,
    },
    {
        id: 35,
        name: 'HitBTC',
        published_at: '2022-11-11T06:40:56.000Z',
        created_at: '2022-02-15T23:48:16.000Z',
        updated_at: '2022-11-21T23:29:30.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: false,
        url: 'https://hitbtc.com/xec-to-usdt',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 10,
        trading_pairs: ['BTC', 'USDT'],
        withdrawal_fee: 150000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 31,
            name: 'hitbtc.png',
            alternativeText: '',
            caption: '',
            width: 400,
            height: 184,
            formats: {
                thumbnail: {
                    name: 'thumbnail_hitbtc.png',
                    hash: 'thumbnail_hitbtc_7016491270',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 113,
                    size: 9.34,
                    path: null,
                    url: '/uploads/thumbnail_hitbtc_7016491270.png',
                },
            },
            hash: 'hitbtc_7016491270',
            ext: '.png',
            mime: 'image/png',
            size: 10.19,
            url: '/uploads/hitbtc_7016491270.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:51.000Z',
            updated_at: '2022-02-10T21:24:51.000Z',
        },
        score: 50,
    },
    {
        id: 23,
        name: 'Ascendex',
        published_at: '2022-02-15T23:26:01.000Z',
        created_at: '2022-02-15T23:25:59.000Z',
        updated_at: '2022-10-21T08:13:43.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: false,
        url: 'https://ascendex.com/en/cashtrade-spottrading/usdt/xec',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 15,
        trading_pairs: ['USDT'],
        withdrawal_fee: 10000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'AED',
            'ARS',
            'AUD',
            'AZN',
            'BGN',
            'BRL',
            'CAD',
            'CHF',
            'CLP',
            'COP',
            'CRC',
            'CZK',
            'DKK',
            'DOP',
            'EGP',
            'EUR',
            'GBP',
            'GEL',
            'GHS',
            'HKD',
            'HRK',
            'HUF',
            'IDR',
            'ILS',
            'INR',
            'JOD',
            'JPY',
            'KES',
            'KRW',
            'KWD',
            'KZT',
            'LKR',
            'MDL',
            'MXN',
            'MYR',
            'NAD',
            'NGN',
            'NOK',
            'NZD',
            'OMR',
            'PEN',
            'PHP',
            'PKR',
            'PLN',
            'QAR',
            'RON',
            'RUB',
            'SAR',
            'SEK',
            'SGD',
            'THB',
            'TRY',
            'TWD',
            'TZS',
            'UAH',
            'UGX',
            'USD',
            'UYU',
            'UZS',
            'VND',
            'ZAR',
        ],
        logo: {
            id: 5,
            name: 'ascendex.png',
            alternativeText: '',
            caption: '',
            width: 500,
            height: 100,
            formats: {
                thumbnail: {
                    name: 'thumbnail_ascendex.png',
                    hash: 'thumbnail_ascendex_68ea0e377c',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 49,
                    size: 5.81,
                    path: null,
                    url: '/uploads/thumbnail_ascendex_68ea0e377c.png',
                },
            },
            hash: 'ascendex_68ea0e377c',
            ext: '.png',
            mime: 'image/png',
            size: 4.92,
            url: '/uploads/ascendex_68ea0e377c.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:49.000Z',
            updated_at: '2022-10-21T08:15:24.000Z',
        },
        score: 40,
    },
    {
        id: 34,
        name: 'Bybit',
        published_at: '2022-02-15T23:47:02.000Z',
        created_at: '2022-02-15T23:47:00.000Z',
        updated_at: '2022-10-21T08:22:39.000Z',
        ecash_brand: true,
        decimal_places: 1,
        ecash_deposit_address_format: false,
        url: 'https://www.bybit.com/trade/spot/XEC/USDT',
        deposits_working: true,
        withdrawals_working: true,
        deposit_confirmations: 60,
        trading_pairs: ['USDT'],
        withdrawal_fee: 10000,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 18,
            name: 'bybit.png',
            alternativeText: 'Bybit',
            caption: '',
            width: 767,
            height: 266,
            formats: {
                thumbnail: {
                    name: 'thumbnail_bybit.png',
                    hash: 'thumbnail_bybit_303e7734d1',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 85,
                    size: 4.97,
                    path: null,
                    url: '/uploads/thumbnail_bybit_303e7734d1.png',
                },
                medium: {
                    name: 'medium_bybit.png',
                    hash: 'medium_bybit_303e7734d1',
                    ext: '.png',
                    mime: 'image/png',
                    width: 750,
                    height: 260,
                    size: 16.96,
                    path: null,
                    url: '/uploads/medium_bybit_303e7734d1.png',
                },
                small: {
                    name: 'small_bybit.png',
                    hash: 'small_bybit_303e7734d1',
                    ext: '.png',
                    mime: 'image/png',
                    width: 500,
                    height: 173,
                    size: 10.32,
                    path: null,
                    url: '/uploads/small_bybit_303e7734d1.png',
                },
            },
            hash: 'bybit_303e7734d1',
            ext: '.png',
            mime: 'image/png',
            size: 3.66,
            url: '/uploads/bybit_303e7734d1.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-02-10T21:24:50.000Z',
            updated_at: '2022-10-21T08:22:33.000Z',
        },
        score: 40,
    },
    {
        id: 40,
        name: 'Hotcoin',
        published_at: '2022-09-17T01:55:47.000Z',
        created_at: '2022-06-23T05:44:32.000Z',
        updated_at: '2022-11-18T21:33:12.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: true,
        url: 'https://www.hotcoin.com/currencyExchange/xec_usdt',
        deposits_working: false,
        withdrawals_working: false,
        deposit_confirmations: 11,
        trading_pairs: ['USDT'],
        withdrawal_fee: null,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [
            'CNY',
            'USD',
            'EUR',
            'GBP',
            'AED',
            'AMD',
            'ARS',
            'AUD',
            'BDT',
            'BHD',
            'BND',
            'BOB',
            'RSL',
            'CAD',
            'CLP',
            'COP',
            'DOP',
            'EGP',
            'GHS',
            'HKD',
            'IDR',
            'INR',
            'JPY',
            'KES',
            'KHR',
            'KWD',
            'KZT',
            'LAK',
            'LKR',
            'MAD',
            'MMK',
            'MNT',
            'MXN',
            'NGN',
            'NPR',
            'PAB',
            'PEN',
            'PHP',
            'PKR',
            'PLN',
            'PYG',
            'RON',
            'RUB',
            'VND',
            'THB',
            'TRY',
        ],
        logo: {
            id: 78,
            name: 'hotcoin logo-1.png',
            alternativeText: 'Hotcoin',
            caption: '',
            width: 334,
            height: 50,
            formats: {
                thumbnail: {
                    name: 'thumbnail_hotcoin logo-1.png',
                    hash: 'thumbnail_hotcoin_logo_1_7cd6c68edc',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 37,
                    size: 5.14,
                    path: null,
                    url: '/uploads/thumbnail_hotcoin_logo_1_7cd6c68edc.png',
                },
            },
            hash: 'hotcoin_logo_1_7cd6c68edc',
            ext: '.png',
            mime: 'image/png',
            size: 3.63,
            url: '/uploads/hotcoin_logo_1_7cd6c68edc.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-09-17T01:00:35.000Z',
            updated_at: '2022-11-18T21:33:09.000Z',
        },
        score: 30,
    },
    {
        id: 45,
        name: 'XT.com',
        published_at: '2022-11-30T20:14:13.000Z',
        created_at: '2022-11-29T06:28:27.000Z',
        updated_at: '2022-11-30T20:14:13.000Z',
        ecash_brand: true,
        decimal_places: 0,
        ecash_deposit_address_format: null,
        url: 'https://www.xt.com/tradePro/xec_usdt',
        deposits_working: false,
        withdrawals_working: false,
        deposit_confirmations: null,
        trading_pairs: ['USDT'],
        withdrawal_fee: null,
        xec_withdrawal_fee: null,
        quirks_issues: null,
        withdrawal_fee_currency: 'XEC',
        fiat_deposit_options: [''],
        logo: {
            id: 92,
            name: 'xt_com_logo-freelogovectors.net_.png',
            alternativeText: '',
            caption: '',
            width: 320,
            height: 92,
            formats: {
                thumbnail: {
                    name: 'thumbnail_xt_com_logo-freelogovectors.net_.png',
                    hash: 'thumbnail_xt_com_logo_freelogovectors_net_274dddb9b6',
                    ext: '.png',
                    mime: 'image/png',
                    width: 245,
                    height: 70,
                    size: 7.3,
                    path: null,
                    url: '/uploads/thumbnail_xt_com_logo_freelogovectors_net_274dddb9b6.png',
                },
            },
            hash: 'xt_com_logo_freelogovectors_net_274dddb9b6',
            ext: '.png',
            mime: 'image/png',
            size: 7.65,
            url: '/uploads/xt_com_logo_freelogovectors_net_274dddb9b6.png',
            previewUrl: null,
            provider: 'local',
            provider_metadata: null,
            created_at: '2022-11-29T06:34:39.000Z',
            updated_at: '2022-11-29T06:34:39.000Z',
        },
        score: 25,
    },
];

export const sortedMockInstantExchanges = [
    {
        id: 4,
        name: 'Change Now',
        published_at: '2022-08-11T00:42:44.000Z',
        created_at: '2022-08-11T00:41:43.000Z',
        updated_at: '2022-10-21T11:12:13.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: null,
        decimal_place: null,
        ecash_deposit_address_format: true,
        url: 'https://changenow.io/?from=xec&to=usdttrc20',
        logo: [
            {
                id: 75,
                name: 'change-now.png',
                alternativeText: 'ChangeNOW',
                caption: '',
                width: 213,
                height: 150,
                formats: {},
                hash: 'change_now_fde3e4f2fa',
                ext: '.png',
                mime: 'image/png',
                size: 3.31,
                url: '/uploads/change_now_fde3e4f2fa.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-08-11T00:41:04.000Z',
                updated_at: '2022-10-21T11:12:11.000Z',
            },
        ],
        score: 90,
    },
    {
        id: 5,
        name: 'LetsExchange',
        published_at: '2022-09-16T20:27:49.000Z',
        created_at: '2022-09-16T20:27:38.000Z',
        updated_at: '2023-06-07T22:48:57.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: null,
        decimal_place: 8,
        ecash_deposit_address_format: true,
        url: 'https://letsexchange.io/',
        logo: [
            {
                id: 77,
                name: 'letsexchange.png',
                alternativeText: 'LetsExchange',
                caption: '',
                width: 380,
                height: 50,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_letsexchange.png',
                        hash: 'thumbnail_letsexchange_9a542bc886',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 32,
                        size: 5.52,
                        path: null,
                        url: '/uploads/thumbnail_letsexchange_9a542bc886.png',
                    },
                },
                hash: 'letsexchange_9a542bc886',
                ext: '.png',
                mime: 'image/png',
                size: 5.34,
                url: '/uploads/letsexchange_9a542bc886.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-09-16T20:25:25.000Z',
                updated_at: '2022-11-18T21:33:32.000Z',
            },
        ],
        score: 90,
    },
    {
        id: 8,
        name: 'Quickex',
        published_at: '2023-06-12T04:18:18.000Z',
        created_at: '2023-06-12T04:18:07.000Z',
        updated_at: '2023-06-12T04:18:30.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 1,
        decimal_place: 6,
        ecash_deposit_address_format: true,
        url: 'https://quickex.io/exchange-xec-usdt',
        logo: [
            {
                id: 117,
                name: 'Quickex.png',
                alternativeText: '',
                caption: '',
                width: 458,
                height: 138,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_Quickex.png',
                        hash: 'thumbnail_Quickex_bfc370a633',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 74,
                        size: 7.82,
                        path: null,
                        url: '/uploads/thumbnail_Quickex_bfc370a633.png',
                    },
                },
                hash: 'Quickex_bfc370a633',
                ext: '.png',
                mime: 'image/png',
                size: 5.12,
                url: '/uploads/Quickex_bfc370a633.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-06-12T04:15:09.000Z',
                updated_at: '2023-06-12T04:15:09.000Z',
            },
        ],
        score: 90,
    },
    {
        id: 7,
        name: 'Changelly',
        published_at: '2023-01-10T12:02:41.000Z',
        created_at: '2023-01-10T12:00:45.000Z',
        updated_at: '2023-02-20T10:58:21.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 10,
        decimal_place: 2,
        ecash_deposit_address_format: true,
        url: 'https://changelly.com/?from=btc&to=xec&utm_medium=social&utm_source=twitter&utm_campaign=listing',
        logo: [
            {
                id: 96,
                name: 'horizontal-changelly-logo-4.png',
                alternativeText: '',
                caption: '',
                width: 770,
                height: 200,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_horizontal-changelly-logo-4.png',
                        hash: 'thumbnail_horizontal_changelly_logo_4_d605d09204',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 64,
                        size: 7.13,
                        path: null,
                        url: '/uploads/thumbnail_horizontal_changelly_logo_4_d605d09204.png',
                    },
                    medium: {
                        name: 'medium_horizontal-changelly-logo-4.png',
                        hash: 'medium_horizontal_changelly_logo_4_d605d09204',
                        ext: '.png',
                        mime: 'image/png',
                        width: 750,
                        height: 195,
                        size: 31.59,
                        path: null,
                        url: '/uploads/medium_horizontal_changelly_logo_4_d605d09204.png',
                    },
                    small: {
                        name: 'small_horizontal-changelly-logo-4.png',
                        hash: 'small_horizontal_changelly_logo_4_d605d09204',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 130,
                        size: 18.56,
                        path: null,
                        url: '/uploads/small_horizontal_changelly_logo_4_d605d09204.png',
                    },
                },
                hash: 'horizontal_changelly_logo_4_d605d09204',
                ext: '.png',
                mime: 'image/png',
                size: 10.92,
                url: '/uploads/horizontal_changelly_logo_4_d605d09204.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-01-10T12:02:36.000Z',
                updated_at: '2023-01-10T12:02:36.000Z',
            },
        ],
        score: 80,
    },
    {
        id: 6,
        name: 'EasyBit',
        published_at: '2022-10-21T22:56:40.000Z',
        created_at: '2022-10-21T22:50:10.000Z',
        updated_at: '2022-11-16T05:17:46.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 2,
        ecash_deposit_address_format: true,
        url: 'https://easybit.com/en/exchange#xec',
        logo: [
            {
                id: 85,
                name: 'EasyBit-logo.png',
                alternativeText: '',
                caption: '',
                width: 320,
                height: 86,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_EasyBit-logo.png',
                        hash: 'thumbnail_Easy_Bit_logo_342eaf5425',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 66,
                        size: 6.69,
                        path: null,
                        url: '/uploads/thumbnail_Easy_Bit_logo_342eaf5425.png',
                    },
                },
                hash: 'Easy_Bit_logo_342eaf5425',
                ext: '.png',
                mime: 'image/png',
                size: 3.2,
                url: '/uploads/Easy_Bit_logo_342eaf5425.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-10-21T22:58:36.000Z',
                updated_at: '2022-10-21T22:58:36.000Z',
            },
        ],
        score: 80,
    },
    {
        id: 2,
        name: 'Godex',
        published_at: '2022-02-16T03:31:42.000Z',
        created_at: '2022-02-16T03:31:40.000Z',
        updated_at: '2022-10-21T11:12:31.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 8,
        ecash_deposit_address_format: true,
        url: 'https://godex.io/exchange?coin_from=USDT&coin_to=XEC&amount=500',
        logo: [
            {
                id: 27,
                name: 'godex.png',
                alternativeText: 'Godex',
                caption: '',
                width: 400,
                height: 106,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_godex.png',
                        hash: 'thumbnail_godex_c43971ace3',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 65,
                        size: 5.59,
                        path: null,
                        url: '/uploads/thumbnail_godex_c43971ace3.png',
                    },
                },
                hash: 'godex_c43971ace3',
                ext: '.png',
                mime: 'image/png',
                size: 2.27,
                url: '/uploads/godex_c43971ace3.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:12:30.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 1,
        name: 'StealthEX',
        published_at: '2022-02-16T03:28:45.000Z',
        created_at: '2022-02-16T03:28:43.000Z',
        updated_at: '2022-10-21T11:13:10.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 8,
        ecash_deposit_address_format: true,
        url: 'https://stealthex.io/coin/xec',
        logo: [
            {
                id: 54,
                name: 'stealthex.png',
                alternativeText: 'StealthEX',
                caption: '',
                width: 793,
                height: 148,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_stealthex.png',
                        hash: 'thumbnail_stealthex_691f504038',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 46,
                        size: 6.33,
                        path: null,
                        url: '/uploads/thumbnail_stealthex_691f504038.png',
                    },
                    medium: {
                        name: 'medium_stealthex.png',
                        hash: 'medium_stealthex_691f504038',
                        ext: '.png',
                        mime: 'image/png',
                        width: 750,
                        height: 140,
                        size: 21.64,
                        path: null,
                        url: '/uploads/medium_stealthex_691f504038.png',
                    },
                    small: {
                        name: 'small_stealthex.png',
                        hash: 'small_stealthex_691f504038',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 93,
                        size: 13.83,
                        path: null,
                        url: '/uploads/small_stealthex_691f504038.png',
                    },
                },
                hash: 'stealthex_691f504038',
                ext: '.png',
                mime: 'image/png',
                size: 3.94,
                url: '/uploads/stealthex_691f504038.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-10-21T11:13:09.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 3,
        name: 'SimpleSwap',
        published_at: '2022-02-16T03:32:23.000Z',
        created_at: '2022-02-16T03:32:18.000Z',
        updated_at: '2022-10-21T11:12:58.000Z',
        trading_open: true,
        ecash_brand: true,
        ecash_address_format: null,
        deposit_confirmations: 11,
        decimal_place: 8,
        ecash_deposit_address_format: false,
        url: 'https://simpleswap.io/?to=xec',
        logo: [
            {
                id: 49,
                name: 'simpleswap.png',
                alternativeText: 'SimpleSwap',
                caption: '',
                width: 400,
                height: 77,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_simpleswap.png',
                        hash: 'thumbnail_simpleswap_5e3be28a36',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 47,
                        size: 6.38,
                        path: null,
                        url: '/uploads/thumbnail_simpleswap_5e3be28a36.png',
                    },
                },
                hash: 'simpleswap_5e3be28a36',
                ext: '.png',
                mime: 'image/png',
                size: 3.11,
                url: '/uploads/simpleswap_5e3be28a36.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-10-21T11:12:56.000Z',
            },
        ],
        score: 40,
    },
];

export const sortedMockServices = [
    {
        id: 20,
        name: 'Badger Universal Token',
        url: 'https://bux.digital/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T17:02:40.000Z',
        created_at: '2023-02-17T16:45:26.000Z',
        updated_at: '2023-02-17T17:09:44.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 110,
                name: 'BUX.Digital',
                alternativeText: 'Badger Universal Token',
                caption: '',
                width: 302,
                height: 48,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_BUX.Digital',
                        hash: 'thumbnail_bux_digital_7cb745f6ad',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 39,
                        size: 5.14,
                        path: null,
                        url: '/uploads/thumbnail_bux_digital_7cb745f6ad.png',
                    },
                },
                hash: 'bux_digital_7cb745f6ad',
                ext: '.png',
                mime: 'image/png',
                size: 2.63,
                url: '/uploads/bux_digital_7cb745f6ad.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T16:53:31.000Z',
                updated_at: '2023-02-24T11:10:40.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 1,
        name: 'be.cash',
        url: 'https://explorer.be.cash/blocks',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:13:05.000Z',
        created_at: '2022-02-16T19:13:04.000Z',
        updated_at: '2022-10-21T11:08:42.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 7,
                name: 'be-cash.png',
                alternativeText: 'be.cash',
                caption: '',
                width: 518,
                height: 205,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_be-cash.png',
                        hash: 'thumbnail_be_cash_aa364bfcb7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 97,
                        size: 7.3,
                        path: null,
                        url: '/uploads/thumbnail_be_cash_aa364bfcb7.png',
                    },
                    small: {
                        name: 'small_be-cash.png',
                        hash: 'small_be_cash_aa364bfcb7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 198,
                        size: 18.35,
                        path: null,
                        url: '/uploads/small_be_cash_aa364bfcb7.png',
                    },
                },
                hash: 'be_cash_aa364bfcb7',
                ext: '.png',
                mime: 'image/png',
                size: 4.95,
                url: '/uploads/be_cash_aa364bfcb7.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:49.000Z',
                updated_at: '2022-10-21T11:08:39.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 13,
        name: 'Cashtab',
        url: 'https://cashtab.com/#/wallet',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-09-26T00:08:06.000Z',
        created_at: '2022-09-26T00:01:31.000Z',
        updated_at: '2022-10-21T11:10:14.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 79,
                name: 'cashtab_xec.png',
                alternativeText: 'Cashtab',
                caption: '',
                width: 710,
                height: 125,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_cashtab_xec.png',
                        hash: 'thumbnail_cashtab_xec_37da0eae8e',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 43,
                        size: 7.31,
                        path: null,
                        url: '/uploads/thumbnail_cashtab_xec_37da0eae8e.png',
                    },
                    small: {
                        name: 'small_cashtab_xec.png',
                        hash: 'small_cashtab_xec_37da0eae8e',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 88,
                        size: 17.29,
                        path: null,
                        url: '/uploads/small_cashtab_xec_37da0eae8e.png',
                    },
                },
                hash: 'cashtab_xec_37da0eae8e',
                ext: '.png',
                mime: 'image/png',
                size: 6.29,
                url: '/uploads/cashtab_xec_37da0eae8e.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-09-26T00:04:55.000Z',
                updated_at: '2022-10-21T11:10:12.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 19,
        name: 'Cert.cash',
        url: 'https://cert.cash/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T09:13:18.000Z',
        created_at: '2023-02-17T09:13:15.000Z',
        updated_at: '2023-02-17T09:15:44.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 107,
                name: 'cert logo.png',
                alternativeText: '',
                caption: '',
                width: 513,
                height: 118,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_cert logo.png',
                        hash: 'thumbnail_cert_logo_949834d8bb',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 56,
                        size: 7.02,
                        path: null,
                        url: '/uploads/thumbnail_cert_logo_949834d8bb.png',
                    },
                    small: {
                        name: 'small_cert logo.png',
                        hash: 'small_cert_logo_949834d8bb',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 115,
                        size: 15.07,
                        path: null,
                        url: '/uploads/small_cert_logo_949834d8bb.png',
                    },
                },
                hash: 'cert_logo_949834d8bb',
                ext: '.png',
                mime: 'image/png',
                size: 5.4,
                url: '/uploads/cert_logo_949834d8bb.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T09:15:39.000Z',
                updated_at: '2023-02-17T09:15:39.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 3,
        name: 'Coin Dance',
        url: 'https://ecash.coin.dance/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-07-27T13:22:25.000Z',
        created_at: '2022-02-16T19:15:36.000Z',
        updated_at: '2022-10-21T11:10:28.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 72,
                name: 'coin-dance.png',
                alternativeText: 'Coin Dance',
                caption: '',
                width: 500,
                height: 102,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coin-dance.png',
                        hash: 'thumbnail_coin_dance_e17caff117',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 50,
                        size: 4.78,
                        path: null,
                        url: '/uploads/thumbnail_coin_dance_e17caff117.png',
                    },
                },
                hash: 'coin_dance_e17caff117',
                ext: '.png',
                mime: 'image/png',
                size: 2.21,
                url: '/uploads/coin_dance_e17caff117.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-07-27T13:24:41.000Z',
                updated_at: '2022-10-21T11:10:26.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 4,
        name: 'CoinGecko',
        url: 'https://www.coingecko.com/en/coins/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:16:19.000Z',
        created_at: '2022-02-16T19:16:18.000Z',
        updated_at: '2022-10-21T11:10:58.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 21,
                name: 'coingecko.png',
                alternativeText: 'CoinGecko',
                caption: '',
                width: 500,
                height: 151,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coingecko.png',
                        hash: 'thumbnail_coingecko_7d6f520f55',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 74,
                        size: 7.1,
                        path: null,
                        url: '/uploads/thumbnail_coingecko_7d6f520f55.png',
                    },
                },
                hash: 'coingecko_7d6f520f55',
                ext: '.png',
                mime: 'image/png',
                size: 5.16,
                url: '/uploads/coingecko_7d6f520f55.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:10:56.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 5,
        name: 'CoinMarketCap',
        url: 'https://coinmarketcap.com/currencies/ecash/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:17:20.000Z',
        created_at: '2022-02-16T19:17:18.000Z',
        updated_at: '2022-10-21T11:11:13.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 22,
                name: 'coinmarketcap.png',
                alternativeText: 'CoinMarketCap',
                caption: '',
                width: 500,
                height: 98,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coinmarketcap.png',
                        hash: 'thumbnail_coinmarketcap_86fb1e6629',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 48,
                        size: 5.71,
                        path: null,
                        url: '/uploads/thumbnail_coinmarketcap_86fb1e6629.png',
                    },
                },
                hash: 'coinmarketcap_86fb1e6629',
                ext: '.png',
                mime: 'image/png',
                size: 4.16,
                url: '/uploads/coinmarketcap_86fb1e6629.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:11:10.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 7,
        name: 'feixiaohao.com',
        url: 'https://www.feixiaohaozh.info/currencies/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: '',
        published_at: '2022-02-16T19:19:21.000Z',
        created_at: '2022-02-16T19:19:20.000Z',
        updated_at: '2023-06-09T05:40:22.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 25,
                name: 'feixiaohao-com.png',
                alternativeText: 'feixiaohao',
                caption: '',
                width: 500,
                height: 120,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_feixiaohao-com.png',
                        hash: 'thumbnail_feixiaohao_com_b8f00e03d7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 59,
                        size: 5.62,
                        path: null,
                        url: '/uploads/thumbnail_feixiaohao_com_b8f00e03d7.png',
                    },
                },
                hash: 'feixiaohao_com_b8f00e03d7',
                ext: '.png',
                mime: 'image/png',
                size: 2.91,
                url: '/uploads/feixiaohao_com_b8f00e03d7.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:11:32.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 18,
        name: 'Gorbeious',
        url: 'https://gorbeious.cash/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T08:54:11.000Z',
        created_at: '2023-02-17T08:52:27.000Z',
        updated_at: '2023-02-17T17:03:46.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 112,
                name: 'gorbeious.png',
                alternativeText: '',
                caption: '',
                width: 600,
                height: 132,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_gorbeious.png',
                        hash: 'thumbnail_gorbeious_fbc936deba',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 54,
                        size: 6.49,
                        path: null,
                        url: '/uploads/thumbnail_gorbeious_fbc936deba.png',
                    },
                    small: {
                        name: 'small_gorbeious.png',
                        hash: 'small_gorbeious_fbc936deba',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 110,
                        size: 17.2,
                        path: null,
                        url: '/uploads/small_gorbeious_fbc936deba.png',
                    },
                },
                hash: 'gorbeious_fbc936deba',
                ext: '.png',
                mime: 'image/png',
                size: 4.74,
                url: '/uploads/gorbeious_fbc936deba.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T17:03:37.000Z',
                updated_at: '2023-02-17T17:03:37.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 6,
        name: 'Livecoinwatch',
        url: 'https://www.livecoinwatch.com/price/eCash-XEC',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2022-02-16T19:17:59.000Z',
        created_at: '2022-02-16T19:17:59.000Z',
        updated_at: '2022-10-21T11:11:53.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 52,
                name: 'livecoinwatch.png',
                alternativeText: 'Live Coin Watch',
                caption: '',
                width: 600,
                height: 77,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_livecoinwatch.png',
                        hash: 'thumbnail_livecoinwatch_3fec7e3a6c',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 31,
                        size: 4.36,
                        path: null,
                        url: '/uploads/thumbnail_livecoinwatch_3fec7e3a6c.png',
                    },
                    small: {
                        name: 'small_livecoinwatch.png',
                        hash: 'small_livecoinwatch_3fec7e3a6c',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 64,
                        size: 10.82,
                        path: null,
                        url: '/uploads/small_livecoinwatch_3fec7e3a6c.png',
                    },
                },
                hash: 'livecoinwatch_3fec7e3a6c',
                ext: '.png',
                mime: 'image/png',
                size: 4.01,
                url: '/uploads/livecoinwatch_3fec7e3a6c.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-10-21T11:11:50.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 17,
        name: 'PayButton',
        url: 'https://paybutton.org/',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: null,
        published_at: '2023-02-17T01:32:32.000Z',
        created_at: '2023-02-17T01:31:38.000Z',
        updated_at: '2023-02-17T01:32:32.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 101,
                name: 'pbLogoNoBorder_white.png',
                alternativeText: '',
                caption: '',
                width: 600,
                height: 112,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_pbLogoNoBorder_white.png',
                        hash: 'thumbnail_pb_Logo_No_Border_white_4821b0d3fd',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 46,
                        size: 5.6,
                        path: null,
                        url: '/uploads/thumbnail_pb_Logo_No_Border_white_4821b0d3fd.png',
                    },
                    small: {
                        name: 'small_pbLogoNoBorder_white.png',
                        hash: 'small_pb_Logo_No_Border_white_4821b0d3fd',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 93,
                        size: 12.41,
                        path: null,
                        url: '/uploads/small_pb_Logo_No_Border_white_4821b0d3fd.png',
                    },
                },
                hash: 'pb_Logo_No_Border_white_4821b0d3fd',
                ext: '.png',
                mime: 'image/png',
                size: 3.68,
                url: '/uploads/pb_Logo_No_Border_white_4821b0d3fd.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-02-17T01:31:30.000Z',
                updated_at: '2023-02-17T01:31:30.000Z',
            },
        ],
        score: 100,
    },
    {
        id: 2,
        name: 'Blockchair',
        url: 'https://blockchair.com/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 2,
        issues: "Stating that more than 1 confirmation is required for finalization and using 'ECash' instead of 'eCash' on the tooltip.",
        published_at: '2022-02-16T19:14:56.000Z',
        created_at: '2022-02-16T19:14:50.000Z',
        updated_at: '2022-10-21T11:10:00.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 12,
                name: 'blockchair.png',
                alternativeText: 'Blockchair',
                caption: '',
                width: 500,
                height: 134,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_blockchair.png',
                        hash: 'thumbnail_blockchair_d20f851724',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 66,
                        size: 5.27,
                        path: null,
                        url: '/uploads/thumbnail_blockchair_d20f851724.png',
                    },
                },
                hash: 'blockchair_d20f851724',
                ext: '.png',
                mime: 'image/png',
                size: 3.24,
                url: '/uploads/blockchair_d20f851724.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:50.000Z',
                updated_at: '2022-10-21T11:09:58.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 23,
        name: 'Flashift',
        url: 'https://exchange.flashift.app/?currency_from=btc&currency_to=xec&amount=0.1',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 8,
        issues: null,
        published_at: '2023-05-03T12:40:30.000Z',
        created_at: '2023-05-03T12:39:35.000Z',
        updated_at: '2023-05-03T12:47:15.000Z',
        fiat_deposit_options: ['N/A'],
        logo: [
            {
                id: 116,
                name: 'Flashift_-BigLogo.png',
                alternativeText: '',
                caption: '',
                width: 620,
                height: 310,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_Flashift_-BigLogo.png',
                        hash: 'thumbnail_Flashift_Big_Logo_d41607b8ce',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 123,
                        size: 8.88,
                        path: null,
                        url: '/uploads/thumbnail_Flashift_Big_Logo_d41607b8ce.png',
                    },
                    small: {
                        name: 'small_Flashift_-BigLogo.png',
                        hash: 'small_Flashift_Big_Logo_d41607b8ce',
                        ext: '.png',
                        mime: 'image/png',
                        width: 500,
                        height: 250,
                        size: 20.18,
                        path: null,
                        url: '/uploads/small_Flashift_Big_Logo_d41607b8ce.png',
                    },
                },
                hash: 'Flashift_Big_Logo_d41607b8ce',
                ext: '.png',
                mime: 'image/png',
                size: 17.31,
                url: '/uploads/Flashift_Big_Logo_d41607b8ce.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2023-05-03T12:42:17.000Z',
                updated_at: '2023-05-03T12:42:17.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 14,
        name: 'SwapSpace',
        url: 'https://swapspace.co/?to=xec&amount=1',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 5,
        issues: null,
        published_at: '2022-11-16T05:23:35.000Z',
        created_at: '2022-11-16T05:21:55.000Z',
        updated_at: '2022-11-16T05:23:35.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 87,
                name: 'SwapSpaceLogoBlackStacked.svg',
                alternativeText: '',
                caption: '',
                width: 710,
                height: 246,
                formats: null,
                hash: 'Swap_Space_Logo_Black_Stacked_98c54408f7',
                ext: '.svg',
                mime: 'image/svg+xml',
                size: 3.86,
                url: '/uploads/Swap_Space_Logo_Black_Stacked_98c54408f7.svg',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-11-16T05:21:49.000Z',
                updated_at: '2022-11-16T05:21:49.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 15,
        name: 'Swapzone',
        url: 'https://swapzone.io/exchange/eth/xec',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 8,
        issues: null,
        published_at: '2022-11-16T05:29:20.000Z',
        created_at: '2022-11-16T05:27:04.000Z',
        updated_at: '2022-11-16T05:29:20.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 88,
                name: 'Swapzone logo (1).svg',
                alternativeText: '',
                caption: '',
                width: 240,
                height: 88,
                formats: null,
                hash: 'Swapzone_logo_1_25d2ec1093',
                ext: '.svg',
                mime: 'image/svg+xml',
                size: 4.59,
                url: '/uploads/Swapzone_logo_1_25d2ec1093.svg',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-11-16T05:27:00.000Z',
                updated_at: '2022-11-16T05:27:00.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 8,
        name: 'ViaWallet Explorer',
        url: 'https://explorer.viawallet.com/xec',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: 8,
        issues: null,
        published_at: '2022-02-16T19:20:45.000Z',
        created_at: '2022-02-16T19:20:13.000Z',
        updated_at: '2022-02-16T19:20:45.000Z',
        fiat_deposit_options: null,
        logo: [
            {
                id: 58,
                name: 'viawallet-explorer.png',
                alternativeText: '',
                caption: '',
                width: 400,
                height: 84,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_viawallet-explorer.png',
                        hash: 'thumbnail_viawallet_explorer_36e2f5944b',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 51,
                        size: 6.99,
                        path: null,
                        url: '/uploads/thumbnail_viawallet_explorer_36e2f5944b.png',
                    },
                },
                hash: 'viawallet_explorer_36e2f5944b',
                ext: '.png',
                mime: 'image/png',
                size: 6.63,
                url: '/uploads/viawallet_explorer_36e2f5944b.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-02-10T21:24:53.000Z',
            },
        ],
        score: 70,
    },
    {
        id: 9,
        name: 'CoinCap.io',
        url: 'https://coincap.io/assets/ecash',
        ecash_brand: true,
        ecash_address_format: true,
        decimal_place: null,
        issues: 'Missing key exchange trading pairs (Upbit, Bithumb, etc).',
        published_at: '2022-02-16T19:21:34.000Z',
        created_at: '2022-02-16T19:21:33.000Z',
        updated_at: '2022-10-21T11:10:43.000Z',
        fiat_deposit_options: [''],
        logo: [
            {
                id: 20,
                name: 'coincap-io.png',
                alternativeText: 'CoinCap',
                caption: '',
                width: 500,
                height: 219,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_coincap-io.png',
                        hash: 'thumbnail_coincap_io_5bbe710c86',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 107,
                        size: 7.07,
                        path: null,
                        url: '/uploads/thumbnail_coincap_io_5bbe710c86.png',
                    },
                },
                hash: 'coincap_io_5bbe710c86',
                ext: '.png',
                mime: 'image/png',
                size: 4.4,
                url: '/uploads/coincap_io_5bbe710c86.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:51.000Z',
                updated_at: '2022-10-21T11:10:42.000Z',
            },
        ],
        score: 40,
    },
    {
        id: 10,
        name: 'Matrixport',
        url: 'https://www.matrixport.com/en',
        ecash_brand: true,
        ecash_address_format: false,
        decimal_place: 2,
        issues: 'No proper eCash services (only supporting deposit and withdrawal) and a high withdrawal fee of 10,000 bits (XEC).',
        published_at: '2022-02-16T19:26:32.000Z',
        created_at: '2022-02-16T19:26:30.000Z',
        updated_at: '2022-02-18T21:39:29.000Z',
        fiat_deposit_options: null,
        logo: [
            {
                id: 44,
                name: 'matrixport.png',
                alternativeText: '',
                caption: '',
                width: 400,
                height: 83,
                formats: {
                    thumbnail: {
                        name: 'thumbnail_matrixport.png',
                        hash: 'thumbnail_matrixport_b76e44ecb7',
                        ext: '.png',
                        mime: 'image/png',
                        width: 245,
                        height: 51,
                        size: 5.57,
                        path: null,
                        url: '/uploads/thumbnail_matrixport_b76e44ecb7.png',
                    },
                },
                hash: 'matrixport_b76e44ecb7',
                ext: '.png',
                mime: 'image/png',
                size: 5.33,
                url: '/uploads/matrixport_b76e44ecb7.png',
                previewUrl: null,
                provider: 'local',
                provider_metadata: null,
                created_at: '2022-02-10T21:24:52.000Z',
                updated_at: '2022-02-10T21:24:52.000Z',
            },
        ],
        score: 30,
    },
];
